﻿/* define cometmarks global const variables */
if( typeof( CometMarksBookMarksDefine ) == "undefined" )
{
	try
	{
		eval('																						\r\n\
			const CometMarksBookMarksDefine =														\r\n\
			{																						\r\n\
				// 收到便签变化																			\r\n\
				event_note_changed			:	"cometmarks.bookmarks.event.note_changed",			\r\n\
				// 收到重画书签																			\r\n\
				event_bookmarks_recover		:	"cometmarks.bookmarks.event.bookmarks_recover"		\r\n\
			};																						\r\n\
		');
	} 
	catch( e ) 
	{
		alert ( e ); 
	}
}

/* comet bookmarks class */
var CometMarksBookMarks = 
{
	/* all members */
	_bookmarksService			: Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService),
	_node_array					: [],
	_fid_array					: [],
	
	/* all methods */
	////////////////////////////////////////////////
	// create bookmarks 
	createElement : function( doc, node_parent, tag, value )
	{
		var elem = doc.createElement( tag );
		elem.textContent = value;
		node_parent.appendChild( elem );
		return elem;
	},

	createElementParent : function( doc, node_parent, tag )
	{
		var elem = doc.createElement(tag);
		node_parent.appendChild(elem);
		return elem;
	},
	
	// bookmark_type = 1:toolbar, 2:menubar, 3:unfiledbar 0:other
	createNode : function( node_bookmarks, bookmark_type, node_parent, doc )
	{
		var node = this.createElementParent( doc, node_parent, "node" );

		// only bookmark ,folder, separator not -1
		if ( node_bookmarks.itemId != -1 )
		{
			if ( bookmark_type == 1 )// toolbar
				this.createElement( doc, node, "guid", "BOOKMARK_TOOLBAR" );
			else if (bookmark_type == 2)// menubar
				this.createElement( doc, node, "guid", "BOOKMARK_MENU" );
			else if (bookmark_type == 3)// unfiledbar
				this.createElement( doc, node, "guid", "BOOKMARK_UNFILED" );
			else// other
				this.createElement( doc, node, "guid", this._bookmarksService.getItemGUID(node_bookmarks.itemId) );
		}

		switch( node_bookmarks.type ) 
		{
			// create separator
			case Components.interfaces.nsINavHistoryResultNode.RESULT_TYPE_SEPARATOR:
			{
				this.createElement( doc, node, "type", "separator" );
			}
			break;
			
			// create uri
			case Components.interfaces.nsINavHistoryResultNode.RESULT_TYPE_URI:
			{
				this.createElement( doc, node, "type", 		"bookmark" );
				this.createElement( doc, node, "name", 		node_bookmarks.title );
				// description
				this.createElement( doc, node, "keyword", 	this._bookmarksService.getKeywordForBookmark(node_bookmarks.itemId) );
				this.createElement( doc, node, "tag", 		node_bookmarks.tags );
				this.createElement( doc, node, "url", 		node_bookmarks.uri );
				this.createElement( doc, node, "created", 	node_bookmarks.dateAdded );
				this.createElement( doc, node, "modified", 	node_bookmarks.lastModified );
				this.createElement( doc, node, "visited", 	node_bookmarks.accessCount );
			}
			break;
			
			// create folder
			case Components.interfaces.nsINavHistoryResultNode.RESULT_TYPE_FOLDER:
			{
				var livemarkService = Components.classes["@mozilla.org/browser/livemark-service;2"].getService(Components.interfaces.nsILivemarkService);
				var is_livemark = livemarkService.isLivemark(node_bookmarks.itemId);
				if ( is_livemark )
					this.createElement( doc, node, "type", "feed" );
				else
					this.createElement( doc, node, "type", "folder" );
		
				this.createElement( doc, node, "name", 		node_bookmarks.title );
				// description
				this.createElement( doc, node, "keyword", 	this._bookmarksService.getKeywordForBookmark(node_bookmarks.itemId) );
				this.createElement( doc, node, "tag", 		node_bookmarks.tags );
				
				if ( is_livemark )
				{
					this.createElement( doc, node, "url", 		livemarkService.getSiteURI(node_bookmarks.itemId).spec );
					this.createElement( doc, node, "feedurl", 	livemarkService.getFeedURI(node_bookmarks.itemId).spec );	
				}
		
				this.createElement( doc, node, "created", 	node_bookmarks.dateAdded );
				this.createElement( doc, node, "modified", 	node_bookmarks.lastModified );
				this.createElement( doc, node, "visited", 	node_bookmarks.accessCount );
		
				node_bookmarks.QueryInterface( Components.interfaces.nsINavHistoryQueryResultNode );
				node_bookmarks.containerOpen = true;
		
				if ( node_bookmarks.childCount != 0 && !is_livemark )
				{
					var children = this.createElementParent( doc, node, "children" );
					for ( var i = 0; i < node_bookmarks.childCount; i++ )
					{
						this.createNode( node_bookmarks.getChild(i), 0, children, doc );
					}
				}
		
				node_bookmarks.containerOpen = false;
			}
			break;
			
			// create query
			case Components.interfaces.nsINavHistoryResultNode.RESULT_TYPE_QUERY:
			{
				this.createElement( doc, node, "type", 		"query" );
				this.createElement( doc, node, "name", 		node_bookmarks.title );
				// description
				this.createElement( doc, node, "keyword", 	this._bookmarksService.getKeywordForBookmark(node_bookmarks.itemId) );
				this.createElement( doc, node, "tag", 		node_bookmarks.tags );
				this.createElement( doc, node, "url", 		node_bookmarks.uri );
				this.createElement( doc, node, "created", 	node_bookmarks.dateAdded );
				this.createElement( doc, node, "modified", 	node_bookmarks.lastModified );
				this.createElement( doc, node, "visited", 	node_bookmarks.accessCount );
			}
			break;

			default: break;
		}
	},
	
	getLocalBookmarksContent : function()
	{
		// prevent occuring onItemChanged event
		BookmarkListener.is_recover_bookmarks = true;

		write_log(">>>begin to get bookmarks: "+ CometMarksUtility.getCurrentTime());
		var xmldoc = document.implementation.createDocument( "","",null );
		var head = xmldoc.createProcessingInstruction( "xml","version=\"1.0\"  encoding=\"UTF-8\" standalone=\"yes\"" );
		xmldoc.appendChild( head ); 
		var nodest = xmldoc.createElement( "nodeset" );
		
		var historyService = Components.classes["@mozilla.org/browser/nav-history-service;1"].getService(Components.interfaces.nsINavHistoryService);
		var options = historyService.getNewQueryOptions();
		var query_toolbar = historyService.getNewQuery();
		var query_menubar = historyService.getNewQuery();
		var query_unfiledbar = historyService.getNewQuery();
		
		query_toolbar.setFolders( [this._bookmarksService.toolbarFolder], 1 );
		var result_toolbar = historyService.executeQuery( query_toolbar, options );
		var rootNode_toolbar = result_toolbar.root;	// toolbar node
		
		query_menubar.setFolders( [this._bookmarksService.bookmarksMenuFolder], 1 );
		var result_menubar = historyService.executeQuery( query_menubar, options );
		var rootNode_menubar = result_menubar.root;	// menubar node
		
		query_unfiledbar.setFolders( [this._bookmarksService.unfiledBookmarksFolder], 1 );
		var result_unfiledbar = historyService.executeQuery( query_unfiledbar, options );
		var rootNode_unfiledbar = result_unfiledbar.root;	// unfiledbar node
		
		var node = this.createElementParent( xmldoc, nodest, "node" );
		this.createElement( xmldoc, node, "guid", "ROOT" );
		this.createElement( xmldoc, node, "type", "folder" );
		
		var children = this.createElementParent( xmldoc, node, "children" );
		rootNode_toolbar.containerOpen = true;
		this.createNode( rootNode_toolbar, 1, children, xmldoc );
		rootNode_toolbar.containerOpen = false;
		
		rootNode_menubar.containerOpen = true;
		this.createNode( rootNode_menubar, 2, children, xmldoc );
		rootNode_menubar.containerOpen = false;
		
		rootNode_unfiledbar.containerOpen = true;
		this.createNode( rootNode_unfiledbar, 3, children, xmldoc );
		rootNode_unfiledbar.containerOpen = false;
		
		write_log("---end get bookmarks and begin to get notes: "+ CometMarksUtility.getCurrentTime());
		// add cometmarks notes
		this.createNoteXml( xmldoc, children );
		write_log("<<<end get notes: "+ CometMarksUtility.getCurrentTime()+"\n");
		
		xmldoc.appendChild( nodest );
		
		var serializer = new XMLSerializer();
		var bookmarks_xml_str = serializer.serializeToString( xmldoc );
		
		BookmarkListener.is_recover_bookmarks = false;
		
		return bookmarks_xml_str;
	}, 

	createNoteXml : function( doc, node_parent )
	{
		// get notes data string
		var note_str = CometMarksKernel.getLocalNotes();
		if ( note_str.length == 0 )
			return;
			
		// add note parent
		var note_node = this.createElementParent( doc, node_parent, "node" );
		this.createElement( doc, note_node, "guid", "BOOKMARK_NOTES" );
		this.createElement( doc, note_node, "type", "folder" );
		this.createElement( doc, note_node, "name", "" );
		this.createElement( doc, note_node, "keyword", "" );
		this.createElement( doc, note_node, "tag", "" );
		this.createElement( doc, note_node, "created", "" );
		this.createElement( doc, note_node, "modified", "" );
		this.createElement( doc, note_node, "visited", "" );
		
		var note_children_node = this.createElementParent( doc, note_node, "children" );

		// anlyze note: convert str to dom struct
		var parser = new DOMParser();
		var doc = parser.parseFromString( note_str, "text/xml");
		 
		var noteset = doc.getElementsByTagName("noteset");
		var note_list = noteset[0].childNodes;
		for ( var i=0; i<note_list.length; i++ )
		{
			if ( note_list[i].nodeType == Node.ELEMENT_NODE )
			{
				var note_info = note_list[i].childNodes;
				var note_data = new Object();
				 
				for ( var j=0; j<note_info.length; j++ )
				{
					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "guid" )
					{
						note_data.guid = note_info[j].textContent;
					}

					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "type" )
					{
						note_data.type = note_info[j].textContent;
					}

					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "name" )
					{
						note_data.title = note_info[j].textContent;
					}

					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "content" )
					{
						note_data.value = note_info[j].textContent;
					}
				}
			  
				// add each note
				var children_node = this.createElementParent( doc, note_children_node, "node" );
				this.createElement( doc, children_node, "guid", note_data.guid );
				this.createElement( doc, children_node, "type", note_data.type );
				this.createElement( doc, children_node, "name", note_data.title );
				this.createElement( doc, children_node, "content", note_data.value );
			}
		}
	},
	
	////////////////////////////////////////////////
	// recover bookmarks 
	recover : function()
	{
		if ( !CometMarksRoutine.isHasPrivilege() ) // do nothing
			return;
			
		// set recover flag
		BookmarkListener.is_recover_bookmarks = true;

		// remove old bookmarks
		this._bookmarksService.removeFolderChildren( this._bookmarksService.toolbarFolder );
		this._bookmarksService.removeFolderChildren( this._bookmarksService.bookmarksMenuFolder );
		this._bookmarksService.removeFolderChildren( this._bookmarksService.unfiledBookmarksFolder );
		
		// get bookmarks nodes from bookmarksmxl into node_array
		write_log("\n>>>begin to create bookmarks notes: "+ CometMarksUtility.getCurrentTime());
		this.getNodesFromXml();
		write_log("---end create bookmaks notes and begin to recover: "+ CometMarksUtility.getCurrentTime());

		// begin to draw bookmarks from node_array's nodes
		this.beginRecover();
		write_log("<<<end recover: "+ CometMarksUtility.getCurrentTime() +"\n");
		
		// finish recover
		BookmarkListener.is_recover_bookmarks = false;
		
		// clear temp data
		while ( this._node_array.length > 0 )
			this._node_array.shift();	
			
		while ( this._fid_array.length > 0 )
			this._fid_array.shift();
	},
	
	beginRecover : function()
	{
		var callback = 
		{		  
			runBatched: function()
			{
				var node = null;
				var fid = null;
				
				while ( CometMarksBookMarks._node_array.length > 0 )
				{					
					node = CometMarksBookMarks._node_array.shift();
					if ( node.guid == "BOOKMARK_TOOLBAR" || node.guid == "BOOKMARK_MENU" || node.guid == "BOOKMARK_UNFILED" )
						continue;
						
					if ( node.pguid == "BOOKMARK_TOOLBAR" )
						fid = CometMarksBookMarks._bookmarksService.toolbarFolder;
					else if ( node.pguid == "BOOKMARK_MENU" )
						fid = CometMarksBookMarks._bookmarksService.bookmarksMenuFolder;
					else if ( node.pguid == "BOOKMARK_UNFILED" )
						fid = CometMarksBookMarks._bookmarksService.unfiledBookmarksFolder;
					else
					{
						for ( var i=0; i<CometMarksBookMarks._fid_array.length; i++ )
						{
							if( node.pguid == CometMarksBookMarks._fid_array[i].guid )
							{
								fid = CometMarksBookMarks._fid_array[i].fid;
								break;
							}
						}
					}
	
					if ( fid == null )
						continue;
					fid = CometMarksBookMarks.draw( node, fid );// draw bookmark here

					var node_fid = new Object();
					node_fid.guid = node.guid;
					node_fid.fid = fid;
					CometMarksBookMarks._fid_array.push( node_fid );
				}
			}
		};
		
		try
		{
			CometMarksBookMarks._bookmarksService.runInBatchMode( callback, null );   
		} 
		catch(e) 
		{ 
			write_log ( e ); 
		}
	},
	
	bookmarksNode : function( pguid, guid, name, type, url, feedurl, keyword, created, modified, visited, icon, description, tag, children )
	{
		var node = new Object();
		
		node.pguid = pguid;
		node.guid = guid;
		node.name = name;
		node.type = type;
		node.url = url;
		node.feedurl = feedurl;
		node.keyword = keyword;
		node.created = created;
		node.modified = modified;
		node.visited = visited;
		node.icon = icon;
		node.description = description;
		node.tag = tag;
		node.children = children;
		
		return node;
	},
	
	getNodesFromXml : function()
	{
		var content = CometMarksKernel.getBookmarksContent();
		if ( content == "" )
			return;
		
		// convert str to dom struct
		var parser = new DOMParser();
		var doc = parser.parseFromString(content, "text/xml");
			
		var nodeset = doc.getElementsByTagName("nodeset");
		var node_list = nodeset[0].childNodes;
		for ( var m=0; m<node_list.length; m++ )
		{
			if ( node_list[m].nodeType == Node.ELEMENT_NODE )
			{
				var node = node_list[m].childNodes;
				for ( var i=0; i<node.length; i++ )
				{
					if ( node[i].nodeType == Node.ELEMENT_NODE && node[i].tagName == "children" )
					{
						var bookmark_node = node[i].childNodes;
								
						for ( var n=0; n<bookmark_node.length; n++ )
						{
							if ( bookmark_node[n].nodeType == Node.ELEMENT_NODE )
							{
								var guid = "";
								var name = "";
								var url = "";
								var feedurl = "";
								var keyword = "";
								var created = "";
								var modified = "";
								var tag = "";
								var type = "";
								var children = "";
								var icon = "";
								var description = "";
								var visited = "";

								var toolbar_node = bookmark_node[n].childNodes;
								for ( var j=0; j<toolbar_node.length; j++ )
								{
									if ( toolbar_node[j].nodeType == Node.ELEMENT_NODE )
									{										
										if ( toolbar_node[j].tagName == "guid" )
											guid = toolbar_node[j].textContent;
										else if ( toolbar_node[j].tagName == "name" )
											name = toolbar_node[j].textContent;
										else if ( toolbar_node[j].tagName == "type" )
											type = toolbar_node[j].textContent;	
										else if ( toolbar_node[j].tagName == "url" )
											url = toolbar_node[j].textContent;
										else if ( toolbar_node[j].tagName == "feedurl" )
											feedurl = toolbar_node[j].textContent;
										else if ( toolbar_node[j].tagName == "keyword" )
											keyword = toolbar_node[j].textContent;
										else if ( toolbar_node[j].tagName == "created" )
											created = toolbar_node[j].textContent;
										else if ( toolbar_node[j].tagName == "modified" )
											modified = toolbar_node[j].textContent;
										else if ( toolbar_node[j].tagName == "visited" )
											visited = toolbar_node[j].textContent;
										else if ( toolbar_node[j].tagName == "icon" )
											icon = toolbar_node[j].textContent;
										else if ( toolbar_node[j].tagName == "description" )
											description = toolbar_node[j].textContent;// the description value is not used in bookmarks
										else if ( toolbar_node[j].tagName == "tag" )
											tag = toolbar_node[j].textContent;
										else if ( toolbar_node[j].tagName == "children" )
											children = toolbar_node[j].childNodes;
									}
								}
								if ( type == "folder" && guid == "BOOKMARK_TOOLBAR" )// bookmark_toolbar
								{				
									var bookmark_toolbar_node = this.bookmarksNode( null, guid, name, type, url, feedurl, keyword, created, modified, visited, icon, description, tag, children);
									this._node_array.push( bookmark_toolbar_node );
									if ( children != "" && children.length != 0 )
										this.saveBookmarksNodes( bookmark_toolbar_node, children );				
								}
								
								if ( type == "folder" && guid == "BOOKMARK_MENU" )// bookmark_menu
								{				
									var bookmark_menu_node = this.bookmarksNode( null, guid, name, type, url, feedurl, keyword, created, modified, visited, icon, description, tag, children);
									this._node_array.push( bookmark_menu_node );
									if ( children != "" && children.length != 0 )
										this.saveBookmarksNodes(bookmark_menu_node, children);		
								}
								
								if ( type == "folder" && guid == "BOOKMARK_UNFILED" )// bookmark_unfiled
								{				
									var bookmark_unfiled_node = this.bookmarksNode( null, guid, name, type, url, feedurl, keyword, created, modified, visited, icon, description, tag, children);
									this._node_array.push( bookmark_unfiled_node );
									if ( children != "" && children.length != 0 )
										this.saveBookmarksNodes( bookmark_unfiled_node, children );		
								}
								
							}//node
								
						}//for
							
					}
				}
			}
		}
	},
	
	saveBookmarksNodes : function( node, node_list )
	{
		for ( var k=0; k<node_list.length; k++ )
		{
			if ( node_list[k].nodeType == Node.ELEMENT_NODE )
			{					
				var guid = "";
				var name = "";
				var url = "";
				var feedurl = "";
				var keyword = "";
				var created = "";
				var modified = "";
				var visited = "";
				var tag = "";
				var type = "";
				var children = "";
				var icon = "";
				var description = "";
				
				var node_children = node_list[k].childNodes;
				for ( var i=0; i<node_children.length; i++ )
				{			
					if ( node_children[i].nodeType == Node.ELEMENT_NODE )
					{
						if ( node_children[i].tagName == "guid" )
							guid = node_children[i].textContent;
						else if ( node_children[i].tagName == "name" )
							name = node_children[i].textContent;
						else if ( node_children[i].tagName == "type" )
							type = node_children[i].textContent;	
						else if ( node_children[i].tagName == "url" )
							url = node_children[i].textContent;
						else if ( node_children[i].tagName == "feedurl" )
							feedurl = node_children[i].textContent;
						else if ( node_children[i].tagName == "keyword" )
							keyword = node_children[i].textContent;
						else if ( node_children[i].tagName == "created" )
							created = node_children[i].textContent;
						else if ( node_children[i].tagName == "modified" )
							modified = node_children[i].textContent;
						else if ( node_children[i].tagName == "visited" )
							visited = node_children[i].textContent;
						else if ( node_children[i].tagName == "icon" )
							icon = node_children[i].textContent;
						else if ( node_children[i].tagName == "description" )
							description = node_children[i].textContent;
						else if ( node_children[i].tagName == "tag" )
							tag = node_children[i].textContent;
						else if ( node_children[i].tagName == "children" )
							children = node_children[i].childNodes;
					}
				}
				
				var child_node = this.bookmarksNode( node.guid, guid, name, type, url, feedurl, keyword, created, modified, visited, icon, description, tag, children);
				this._node_array.push( child_node );

				if ( children != "" && children.length != 0 )// save its children
				{
					this.saveBookmarksNodes( child_node, child_node.children );
				}
			}
		}
	},
	
	draw : function( node, fid )
	{
		// separator
		if ( node.type == "separator" )
		{
			var separatorId = this._bookmarksService.insertSeparator( fid, -1 );
			if ( separatorId )
			{
				try
				{
					this._bookmarksService.setItemGUID( separatorId, node.guid );
				}
				catch(e)
				{ 
					write_log(e); 
				}
			}
			return separatorId;
		}
		
		// query
		if( node.type == "query" )
		{
			if ( node.url == "" || node.url.length == 0 )
				return null;

			var bookmarkURI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI( node.url, null, null );
			var bookmarkId = this._bookmarksService.insertBookmark( fid, bookmarkURI, -1, node.name );
		
			this._bookmarksService.setKeywordForBookmark( bookmarkId, node.keyword );
			this._bookmarksService.setItemDateAdded( bookmarkId, node.created );
			this._bookmarksService.setItemLastModified( bookmarkId, node.modified );
			
			try
			{
				this._bookmarksService.setItemGUID( bookmarkId, node.guid );
			}
			catch(e)
			{ 
				write_log(e); 
			}
			
			return bookmarkId;
		}
		
		// feed 
		if( node.type == "feed" )
		{

			if ( node.url == "" || node.feedurl == "" )
				return null;

			var IOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		
			var siteURI = IOService.newURI( node.url, null, null );
			var feedURI = IOService.newURI( node.feedurl, null, null );
		
			var livemarks = Components.classes["@mozilla.org/browser/livemark-service;2"].getService(Components.interfaces.nsILivemarkService);
		
			var livemarksId = livemarks.createLivemark( fid, node.name, siteURI, feedURI, -1 );
			try
			{
				this._bookmarksService.setItemGUID( livemarksId, node.guid );
			}
			catch(e)
			{ 
				write_log(e); 
			}
			
			return livemarksId;
		}
		
		// bookmark 
		if ( node.type == "bookmark" ) 
		{
			if ( node.url == "" || node.url.length == 0 )
				return null;
				
			var bookmarkURI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(node.url, null, null);
			var bookmarkId = this._bookmarksService.insertBookmark( fid, bookmarkURI, -1, node.name );
			if ( bookmarkId )
			{
				this._bookmarksService.setKeywordForBookmark( bookmarkId, node.keyword );
				this._bookmarksService.setItemDateAdded( bookmarkId, node.created );
				this._bookmarksService.setItemLastModified( bookmarkId, node.modified );
				try
				{
					this._bookmarksService.setItemGUID( bookmarkId, node.guid );
				}
				catch(e)
				{ 
					write_log(e);
					write_log( "node type: " + node.type );
					write_log( "node guid: " + node.guid );
					write_log( "node url: " + node.url );
				}
			}
			return bookmarkId;
		}
		
		// folder
		if ( node.type == "folder" )
		{
			var folderId = this._bookmarksService.createFolder( fid, node.name, -1 );
			if ( folderId )
			{
				try
				{
					this._bookmarksService.setItemGUID( folderId, node.guid );
				}
				catch(e)
				{ 
					write_log(e);
					write_log( "node type: " + node.type );
					write_log( "node guid: " + node.guid );
				}
			}
			return folderId;
		}
	}
};

// when the bookmark change, it will notify the browser, and update it
var BookmarkListener = 
{
	is_recover_bookmarks  	: false,	
	
	register : function()
	{
		var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
		bookmarksService.addObserver( BookmarkListener, false );
		
		// add observer
		var bserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		bserverService.addObserver( BookmarkListener, CometMarksBookMarksDefine.event_note_changed, false );
		bserverService.addObserver( BookmarkListener, CometMarksBookMarksDefine.event_bookmarks_recover, false );
	},
	
	unRegister : function()
	{
		var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
		if ( BookmarkListener != null && BookmarkListener != undefined )
		{
			bookmarksService.removeObserver( BookmarkListener );
		}
		
		// remove observer
		var bserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		bserverService.removeObserver( BookmarkListener, CometMarksBookMarksDefine.event_note_changed );
		bserverService.removeObserver( BookmarkListener, CometMarksBookMarksDefine.event_bookmarks_recover );
	},
	
	observe: function( subject, topic, data )
	{
		if ( topic == CometMarksBookMarksDefine.event_note_changed )
		{
			this.intervalSyncUpdate( null );
			return;
		}
		
		if ( topic == CometMarksBookMarksDefine.event_bookmarks_recover )
		{
			CometMarksBookMarks.recover();
		}
	},
	
	onBeginUpdateBatch: function() 
	{	
	},
  
	onEndUpdateBatch: function() 
	{
	},
  
	onItemAdded: function(aItemId, aFolder, aIndex) 
	{
		this.intervalSyncUpdate( aItemId );
	},
  
	onItemRemoved: function(aItemId, aFolder, aIndex) 
	{		
		// let replace menu disabled	  	
		var replace_menu = document.getElementById( "cometmarks_replace_menu" );
		if ( replace_menu )
			replace_menu.setAttribute( "disabled", true );
	},
  
	onItemVisited: function(aBookmarkId, aVisitID, time) 
	{
	},
  
	onItemMoved: function(aItemId, aOldParent, aOldIndex, aNewParent, aNewIndex) 
	{	
		this.intervalSyncUpdate( aItemId );
	},
  
	onItemChanged: function(aBookmarkId, aProperty, aIsAnnotationProperty, aValue) 
	{
		// aProperty value: title, url, tags, favicon, cleartime, keyword, bookmarkProperties/description, placesInternal/GUID
		if ( aProperty == "favicon" || aProperty == "tags" || aProperty == "bookmarkProperties/description" || aProperty == "placesInternal/GUID" ) // ignore change with icon, tags, description and placesInternal/GUID
			return;
			
		// other change to update
		this.intervalSyncUpdate( aBookmarkId );
	},
  
	QueryInterface: function(iid) 
	{
		if (iid.equals(Components.interfaces.nsINavBookmarkObserver) || iid.equals(Components.interfaces.nsISupports)) 
		{
		  return this;
		}
		throw Components.results.NS_ERROR_NO_INTERFACE;
	},
	
	// when the bookmark change, commit it interval one minute
	intervalSyncUpdate : function( aBookmarkId )
	{	
		if ( this.is_recover_bookmarks )// if bookmarks recovering, ignore it // on batching
			return;
			
		if ( !CometMarksRoutine.isHasPrivilege() ) // do nothing
			return;
			
		// get kernel state
		var kernelState = CometMarksKernel.getState();
		if ( !kernelState.is_login )// no accout has login, ignore it
			return;
			
		if ( this.isFeedNode(aBookmarkId) )// the bookmark is feed or in feed place, ignore
			return;
				
		// get globalData
		var globalData = CometMarksGlobal.getGlobalData();
		
		var now = new Date();
		var change_time_sec = CometMarksUtility.getSecondsFromTimeStr( now.toGMTString() );
		var lastsync_time_sec = CometMarksUtility.getSecondsFromTimeStr( globalData.last_sync_time );
		
		var sync_time = 3;
		if ( change_time_sec < lastsync_time_sec )
			change_time_sec += 3600;
			
		var offset = change_time_sec - lastsync_time_sec;
		var minimum_sync_interval_sec = CometMarksUtility.getMinimumSyncIntervalSec();// get from pref.js, and default is 1 * 60
		if ( offset > minimum_sync_interval_sec - 1 || offset < 4 ) // more than minimum_sync_interval_sec or less than 4
			sync_time = 3;
		else  // between 4 and minimum_sync_interval_sec
			sync_time = minimum_sync_interval_sec - offset;
		
		// update ui		
		CometMarksUtility.setNextSyncTime( sync_time );
		CometMarksKernel.bookmarksChanged();
	},
	
	isFeedNode : function( aBookmarkId )
	{
		if ( aBookmarkId == null )
			return false;
		
		var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);		
		var livemarkService = Components.classes["@mozilla.org/browser/livemark-service;2"].getService(Components.interfaces.nsILivemarkService);
		var is_livemark = livemarkService.isLivemark(aBookmarkId);
		if ( is_livemark )// is feed or in feed place
		{
			return true;
		}
		
		if ( aBookmarkId == bookmarksService.placesRoot )// normal node
		{
			return false;
		}
			
		var pfolder = bookmarksService.getFolderIdForItem( aBookmarkId );
		return this.isFeedNode( pfolder );
	}
};

// add global event listerner
window.addEventListener("load", BookmarkListener.register, false);
window.addEventListener("unload", BookmarkListener.unRegister, false);