﻿const googleBookMarksRootGUID = "{A1304C1E-50ED-4d52-A1E5-0CB90C979488}";

/* google bookmarks class */
var GoogleBookMarks = 
{
	_cometNode_array	: [],
	_gBFolder_array		: [],
	_fid_array			: [],
	
	importGbookmarks: function()
	{
		// check has login
		if ( !this.checkSignedCookie() )
		{
			// open login page
			var newTab = gBrowser.addTab( "https://www.google.com/accounts/ServiceLogin" );
			gBrowser.selectedTab = newTab;
			// show popup notify
			setTimeout( "GoogleBookMarks.showLoginInfo('email_login')",1000);
			return;
		}
			
		// get google bookmarks
		this.getGBookmkars();
	},
	
	checkSignedCookie: function() 
	{
		var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
		var i = cookieManager.enumerator;
		while ( i.hasMoreElements() ) 
		{
			var cookie = i.getNext();
			if( cookie instanceof Components.interfaces.nsICookie ) 
			{
				if( cookie.host == ".google.com" && cookie.name == "SID" ) 
				{
					write_log( 'Check Google SignedCookie - login' );
					return true;
				}
			}
		}
		write_log( 'Check Google SignedCookie - no login' );
		return false;
	},
	
	getGBookmkars: function()
	{
		// get google bookmarks
		var req = new XMLHttpRequest();
		req.open("GET", "http://www.google.com/bookmarks/lookup?output=xml", true);
		req.send(null);
		
		req.onreadystatechange = function() 
		{
			if( req.readyState == 4 && req.status == 200 ) 
			{
				var bookmarks_dom = req.responseXML;
				if( bookmarks_dom ) 
				{
					var bookmarks_xml = bookmarks_dom.documentElement.getElementsByTagName('bookmark');
					
					var title = "";
					var url = "";	
					var label = "";
					var icon_url = "";
					var fguid = "";
					
					for(var i = 0; i < bookmarks_xml.length; i++) 
					{
						var item = bookmarks_xml[i];

						title = item.getElementsByTagName('title')[0].childNodes[0].nodeValue; 
						url = item.getElementsByTagName('url')[0].childNodes[0].nodeValue;
						
						// folder
						fguid = "GOOGLE_BOOKMARKS";
						if ( item.getElementsByTagName('labels')[0] )
						{
							label = item.getElementsByTagName('labels')[0].childNodes[0].childNodes[0].nodeValue;
							
							if ( GoogleBookMarks.isInFolderList(label) )
								fguid = GoogleBookMarks.isInFolderList(label);
							else
							{
								// create folder
								fguid = CometMarksUtility.createGuid();
								var gb_folder = GoogleBookMarks.gbookmarksNode( "GOOGLE_BOOKMARKS", fguid, label, "folder", "", "" );
								
								GoogleBookMarks._cometNode_array.push( gb_folder );
								GoogleBookMarks._gBFolder_array.push( gb_folder );
							}
						}
						
						if ( item.getElementsByTagName('attributes')[0] && item.getElementsByTagName('attributes')[0].firstChild )
						{
							try
							{
								var icon_name = item.getElementsByTagName('attributes')[0].firstChild.firstChild.childNodes[0].nodeValue;
								if ( icon_name == "favicon_url" )
								{
									icon_url = item.getElementsByTagName('attributes')[0].firstChild.firstChild.nextSibling.childNodes[0].nodeValue;
								}
							}catch(e){}
						}
						
						// create bookmarks
						var bguid = CometMarksUtility.createGuid();
						var gb_bookmark = GoogleBookMarks.gbookmarksNode( fguid, bguid, title, "bookmark", url, icon_url );
						GoogleBookMarks._cometNode_array.push( gb_bookmark );
					}
				}
				else
				{
					write_log("bookmarks_xml is null! " );
				}
				
				// begin to drow bookmarks
				BookmarkListener.is_recover_bookmarks = true;
				if ( GoogleBookMarks.drowGBookmarks() )
				{
					// show popup success
					setTimeout( "GoogleBookMarks.showLoginInfo('import_success')",500);
				}
				else
				{
					// show popup failed
					setTimeout( "GoogleBookMarks.showLoginInfo('import_failed')",500);
				}
				BookmarkListener.is_recover_bookmarks = false;
				
				// commit to server
				BookmarkListener.intervalSyncUpdate( null );
				
				// clear temp data
				while ( GoogleBookMarks._cometNode_array.length > 0 )
					GoogleBookMarks._cometNode_array.shift();
					
				while ( GoogleBookMarks._gBFolder_array.length > 0 )
					GoogleBookMarks._gBFolder_array.shift();
				
				while ( GoogleBookMarks._fid_array.length > 0 )
					GoogleBookMarks._fid_array.shift();
			}
		}
	},
	
	gbookmarksNode: function( pguid, guid, name, type, url, icon )
	{
		var node = new Object();
		
		node.pguid = pguid;
		node.guid = guid;
		node.name = name;
		node.type = type;
		node.url = url;
		node.icon = icon;

		node.keyword = "";
		node.modified = "";
		
		return node;
	},
	
	isInFolderList: function( fname )
	{
		for ( var i=0; i<this._gBFolder_array.length; i++ )
		{
			if ( this._gBFolder_array[i].name == fname )
				return this._gBFolder_array[i].guid;
		}
		return null;
	},
	
	drowGBookmarks: function()
	{
		write_log( "---drowGBookmarks begin time: " + CometMarksUtility.getCurrentTime() );
		
		// drow google bookmarks root
		var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
		var toolbarFolder = bookmarksService.toolbarFolder;
		
		// remove first
		var gb_fid = bookmarksService.getItemIdForGUID( googleBookMarksRootGUID );
		if ( gb_fid != -1 )
			bookmarksService.removeFolder( gb_fid );
			
		var gbookmarksfId = bookmarksService.createFolder( toolbarFolder, "GBookMarks", -1 );
		bookmarksService.setItemGUID( gbookmarksfId, googleBookMarksRootGUID );
		
		// drow google bookmarks on batch
		var callback = 
		{		  
			runBatched: function()
			{
				var node = null;
				var fid = null;
				
				while ( GoogleBookMarks._cometNode_array.length > 0 )
				{					
					node = GoogleBookMarks._cometNode_array.shift();
					if ( node.pguid == "GOOGLE_BOOKMARKS" )
						fid = gbookmarksfId;
					else
					{
						for ( var i=0; i<GoogleBookMarks._fid_array.length; i++ )
						{
							if( node.pguid == GoogleBookMarks._fid_array[i].guid )
							{
								fid = GoogleBookMarks._fid_array[i].fid;
								break;
							}
						}
					}
	
					if ( fid == null )
						continue;
					fid = CometMarksBookMarks.draw( node, fid );// draw bookmark here

					var node_fid = new Object();
					node_fid.guid = node.guid;
					node_fid.fid = fid;
					GoogleBookMarks._fid_array.push( node_fid );
				}
			}
		};
		
		try
		{
			var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
			bookmarksService.runInBatchMode( callback, null );   
			
			write_log( "---drowGBookmarks end time: " + CometMarksUtility.getCurrentTime() );
			return true;
		} 
		catch(e) 
		{ 
			write_log ( e ); 
			return false;
		}
	},
	
	showLoginInfo: function( type ) 
	{
		// using popup-blocked in system
		var notificationBox = gBrowser.getNotificationBox();
		var notification = notificationBox.getNotificationWithValue("popup-blocked");
		
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var message = "";
		if ( type == "email_login" )
			message = bubble.GetStringFromName("cometmarks.notify.email_login.text");
		else if ( type == "import_success" )
			message = bubble.GetStringFromName("cometmarks.notify.import_success.text");
		else if ( type == "import_failed" )
			message = bubble.GetStringFromName("cometmarks.notify.import_failed.text");
			
		if ( notification ) 
		{
			notification.label = message;// change
		}
		else 
		{	
			// add button if need
			var buttons = [{
			label: "popupButtonText",
			accessKey: "p",
			popup: null, // blockedPopupOptions
			callback: this.notificationCallback // null
			}];
			
			// show new
			const priority = notificationBox.PRIORITY_WARNING_HIGH;// PRIORITY_INFO_HIGH-gray, PRIORITY_WARNING_HIGH-yellow, PRIORITY_CRITICAL_HIGH-red
			notificationBox.appendNotification( message, 
												"popup-blocked",
												"chrome://cometmarks/skin/logo_16.png",
												priority, 
												null );// buttons
		}	
		
		// close after 10 seconds
		window.setTimeout( function(){ 
			notificationBox.removeCurrentNotification(); 
		}, 10000 );
	},
	
	notificationCallback: function() 
	{
		// deal with button of popup block 
	}
};