﻿/* define kernel const variables */
if( typeof( CometMarksKernelDefine ) == "undefined" )
{
	try
	{
		eval('                            																	\r\n\
			const CometMarksKernelDefine = 																	\r\n\
			{                           																	\r\n\
				/* 事件定义 */																				\r\n\
				// 书签更新完成																				\r\n\
				event_update					:	"cometmarks.kernel.event.update",						\r\n\
				// 书签同步完成																				\r\n\
				event_sync						:	"cometmarks.kernel.event.sync",							\r\n\
				// 覆盖服务器数据完成																		\r\n\
				event_overwrite					:	"cometmarks.kernel.event.overwrite",					\r\n\
				// observe logout																			\r\n\
				event_logout					:	"cometmarks.kernel.event.logout",						\r\n\
				// observe bookmarks changed																\r\n\
				event_bookmarks_changed			:	"cometmarks.kernel.event.bookmarks_changed",			\r\n\
																											\r\n\
				/* 内核状态定义 */																			\r\n\
				// 书签同步处于正常状态																		\r\n\
				work_state_success				:	"cometmarks.kernel.status.idle",						\r\n\
				// 正在进行同步																				\r\n\
				work_state_syncing				:	"cometmarks.kernel.status.syncing",						\r\n\
				// 正在进行更新																				\r\n\
				work_state_updating				:	"cometmarks.kernel.status.updating",					\r\n\
				// 客户端版本过期																			\r\n\
				work_state_out_of_date			:	"cometmarks.kernel.status.out_of_date",					\r\n\
				// 无法服务器服务器																			\r\n\
				work_state_connect_failed		:	"cometmarks.kernel.status.connect_failed",				\r\n\
				// 无用户书签数据																			\r\n\
				work_state_no_record			:	"cometmarks.kernel.status.no_record",					\r\n\
				// 本地书签发生改变																			\r\n\
				work_state_changed				:	"cometmarks.kernel.status.local_changed",				\r\n\
				// 正在覆盖服务器数据																		\r\n\
				work_state_overwriting			:	"cometmarks.kernel.status.overwriting",					\r\n\
				// 未登录书签服务器																			\r\n\
				work_state_no_login				:	"cometmarks.kernel.status.not_login",					\r\n\
				// 密码错误																					\r\n\
				work_state_invalid_password		:	"cometmarks.kernel.status.invalid_password",			\r\n\
				// 异常																						\r\n\
				work_state_exception			:	"cometmarks.kernel.status.exception"					\r\n\
			};																								\r\n\
		');
	} 
	catch( e ) 
	{
		alert ( e ); 
	}
}

/* define cometmarks kernel const variables */
if( typeof( CometMarksKernelGlobal ) == "undefined" )
{
	try
	{
		eval('																						\r\n\
			const CometMarksKernelGlobal =															\r\n\
			{																						\r\n\
				work_state				:	"cometmarks.kernel.global.work_state",					\r\n\
				bookmarks_version		:	"cometmarks.kernel.global.bookmarks_version",			\r\n\
				is_login				:	"cometmarks.kernel.global.is_login"						\r\n\
			};																						\r\n\
		');
	} 
	catch( e ) 
	{
		alert ( e ); 
	}
}

/* cometmarks interface class */
var CometMarksKernel = 
{
	_cometmarks 		: Components.classes["@cometmarks.com/CometMarksExtension;1"].createInstance(Components.interfaces.ICometMarksExtension),

	getState : function()
	{
		var bookmarks_info = this._cometmarks.GetCometMarksInfo();
		var Application = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);

		var kernelState = new Object();
		kernelState.is_login = bookmarks_info.Loginned; 														// 用户是否登陆										
		kernelState.bookmarks_version = bookmarks_info.Bookmarks_Version; 											// 书签版本
		if ( bookmarks_info.Bookmarks_Datetime.length > 0 )
			kernelState.bookmarks_datetime = bookmarks_info.Bookmarks_Datetime; 										// 最后提交时间
		else
			kernelState.bookmarks_datetime = "N/A"; 
		kernelState.work_state = Application.storage.get( CometMarksKernelGlobal.work_state, null ); 				// 工作状态
		
		return kernelState;
	},
	
	getBookmarksContent : function()
	{
		var bookmarks_info = this._cometmarks.GetCometMarksInfo();
		return bookmarks_info.Bookmarks_Content; // 书签内容
	},
	
	synchronize : function()
	{
		write_log("cometmarks begin to sync: " + CometMarksUtility.getCurrentTime());
		
		// notify all ui: syncing state
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		CometMarksGlobal.setData( CometMarksKernelGlobal.work_state, CometMarksKernelDefine.work_state_syncing );
		
		var Application = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
		Application.storage.set( CometMarksKernelGlobal.work_state, CometMarksKernelDefine.work_state_syncing );
		observerService.notifyObservers( null, CometMarksKernelDefine.event_sync, null );
		
		// sync now
		var local_bookmarks_content = CometMarksBookMarks.getLocalBookmarksContent();
		this._cometmarks.Sync( local_bookmarks_content ); 
		write_log("cometmarks end sync: " + CometMarksUtility.getCurrentTime());
	},
	
	setUserName : function( username, password )
	{
		this._cometmarks.SetUserName( username, password);
		
		// to check if login
		var bookmarks_info = this._cometmarks.GetCometMarksInfo();
		if ( bookmarks_info.Loginned )
		{
			this.synchronize();
			return;
		}
		
		this.logIn();
	},
	
	commit : function()
	{
		write_log("cometmarks begin to commit!");
		var local_bookmarks_content = CometMarksBookMarks.getLocalBookmarksContent();
		this._cometmarks.Commit( local_bookmarks_content );
		write_log("cometmarks end to commit!");
	},
	
	merge : function()
	{
		write_log("cometmarks begin to merge!");
		var local_bookmarks_content = CometMarksBookMarks.getLocalBookmarksContent();
		this._cometmarks.CometmarksMerge( local_bookmarks_content );
		write_log("cometmarks end to merge!");
	},
	
	mergeSpecial : function()
	{
		var local_bookmarks_content = CometMarksBookMarks.getLocalBookmarksContent();
		this._cometmarks.MergeSpecial( local_bookmarks_content );
	},
	
	logOut : function()
	{
		// update kernel state
		var Application = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
		Application.storage.set( CometMarksKernelGlobal.work_state, CometMarksKernelDefine.work_state_no_login );
		
		// notify all ui
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.notifyObservers( null, CometMarksKernelDefine.event_logout, null );
		
		// clear temp data
		CometMarksUtility.setNextSyncTime("N/A");
		this._cometmarks.LogOut();
	},
	
	bookmarksChanged : function()
	{
		// update kernel state
		var Application = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
		Application.storage.set( CometMarksKernelGlobal.work_state, CometMarksKernelDefine.work_state_changed );
		CometMarksGlobal.setData( CometMarksGlobalDefine.is_bookmarks_changeded, true );
		
		// notify all ui
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.notifyObservers( null, CometMarksKernelDefine.event_bookmarks_changed, null );
	},
	
	logIn : function() // wait for update call back
	{
		// notify all ui: syncing state
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		CometMarksGlobal.setData( CometMarksKernelGlobal.work_state, CometMarksKernelDefine.work_state_syncing );
		
		var Application = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
		Application.storage.set( CometMarksKernelGlobal.work_state, CometMarksKernelDefine.work_state_syncing );
		
		observerService.notifyObservers( null, CometMarksKernelDefine.event_sync, null );
		
		write_log("cometmarks begin to login!");
		this._cometmarks.LogIn();
		write_log("cometmarks finish to login!");
	},

	cometmarksEqual : function()
	{
		var local_bookmarks_content = CometMarksBookMarks.getLocalBookmarksContent();
		return this._cometmarks.CometmarksEqual( local_bookmarks_content );
	},
	
	getLocalNotes : function()
	{
		var cometmarks_notes = this._cometmarks.GetCometMarksLocalNote();
		var local_notes = {};
		cometmarks_notes.GetLocalNotes( local_notes );
		return local_notes.value;
	},
	
	setLocalNotes : function( local_notes )
	{
		var cometmarks_notes = this._cometmarks.GetCometMarksLocalNote();
		cometmarks_notes.SetLocalNotes( local_notes );
	}
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 实现代码, 以下代码和定义不得在其它模块使用

/* define kernel implemtn const variables */
if( typeof( CometMarksKernelObserverDefine ) == "undefined" )
{
	try
	{
		eval('																			\r\n\
			const CometMarksKernelObserverDefine =										\r\n\
			{																			\r\n\
				/* 事件定义 */															\r\n\
				event_update		:	"cometmarks_update_callback",					\r\n\
				event_sync			:	"cometmarks_sync_callback",						\r\n\
				event_overwrite		:	"cometmarks_overwrite_callback"					\r\n\
			};																			\r\n\
		');
	} 
	catch( e ) 
	{
		alert ( e ); 
	}
}

/* CometMarksKernelObserver class */
var CometMarksKernelObserver = 
{
	/* all members */
	_cometmarks 		: Components.classes["@cometmarks.com/CometMarksExtension;1"].createInstance(Components.interfaces.ICometMarksExtension),
	_observerService 	: Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService),
	_application		: Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication),
  
	// listen observer
	observe : function( subject, topic, data )
	{
		switch ( topic )
		{
			// get from core
			case CometMarksKernelObserverDefine.event_update :
				
				var bookmarks_info = this._cometmarks.GetCometMarksInfo();
				
				// update kernel state and globalData
				if ( "OK" == data )
				{
					var str_now_time = new Date();
					CometMarksGlobal.setData( CometMarksGlobalDefine.last_sync_time, str_now_time.toGMTString() );
					write_log( "update: cometmarks last sync success time: " + CometMarksUtility.formatGmtTime( str_now_time ) );	
					this._application.storage.set( CometMarksKernelGlobal.work_state, bookmarks_info.Current_State );					
				}
				else if ( "cometmarks.kernel.status.connect_failed" == data )// failed
				{
					var str_now_time = new Date();
					CometMarksGlobal.setData( CometMarksGlobalDefine.last_failed_time, str_now_time.toGMTString() );
					write_log( "update: cometmarks last sync failed time: " + CometMarksUtility.formatGmtTime( str_now_time ) );
					this._application.storage.set( CometMarksKernelGlobal.work_state, data );
				}
				else
				{
					this._application.storage.set( CometMarksKernelGlobal.work_state, data );	
				}
			
				CometMarksGlobal.setData( CometMarksGlobalDefine.is_bookmarks_changeded, false );
				
				// notify ui
				this._observerService.notifyObservers( null, CometMarksKernelDefine.event_update, null );
				break; 
				
			case CometMarksKernelObserverDefine.event_overwrite :
				CometMarksGlobal.setData( CometMarksGlobalDefine.is_bookmarks_changeded, false );
				
				// notify ui
				this._observerService.notifyObservers( null, CometMarksKernelDefine.event_overwrite, null );
				break; 
				
			case CometMarksKernelObserverDefine.event_sync :
				
				var bookmarks_info = this._cometmarks.GetCometMarksInfo();
				
				// update kernel state and globalData
				if ( "OK" == data )
				{
					var str_now_time = new Date();
					CometMarksGlobal.setData( CometMarksGlobalDefine.last_sync_time, str_now_time.toGMTString() );	
					write_log( "sync: cometmarks last sync success time: " + CometMarksUtility.formatGmtTime( str_now_time ) );					
					this._application.storage.set( CometMarksKernelGlobal.work_state, bookmarks_info.Current_State );
				}
				else if ( "cometmarks.kernel.status.connect_failed" == data )// failed
				{
					var str_now_time = new Date();
					CometMarksGlobal.setData( CometMarksGlobalDefine.last_failed_time, str_now_time.toGMTString() );
					write_log( "sync: cometmarks last sync failed time: " + CometMarksUtility.formatGmtTime( str_now_time ) );
					this._application.storage.set( CometMarksKernelGlobal.work_state, data );
				}
				else
				{
					this._application.storage.set( CometMarksKernelGlobal.work_state, data );
				}
				
				CometMarksGlobal.setData( CometMarksGlobalDefine.is_bookmarks_changeded, false );
				
				// notify ui
				this._observerService.notifyObservers( null, CometMarksKernelDefine.event_sync, null );
				break; 
			
			case CometMarksRoutineDefine.event_devolution:
				CometMarksKernelImpl.start();
				break;
			
			case CometPassportDefine.event_saved :

				var kernelState = CometMarksKernel.getState();			
				if ( kernelState.is_login )
				{
					// logout
					CometMarksKernel.logOut();
				}
					
				// get username and password
				var aUsername = CometPassport.getUsername();
				var aPassword = CometPassport.getPassword();
				if ( aUsername == "" || aPassword == "" )
				{
					CometMarksKernel.logOut();
					return;
				}
					
				// set username
				CometMarksKernel.setUserName( aUsername, aPassword );
				
				break;	
			default :
				break;
		}
	}
};

/* cometmarks impl class */
var CometMarksKernelImpl = 
{
	/* all members */
	_cometmarks 	: Components.classes["@cometmarks.com/CometMarksExtension;1"].createInstance(Components.interfaces.ICometMarksExtension),
	
	/* all methods */
	init : function()
	{
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver( CometMarksKernelObserver, CometMarksRoutineDefine.event_devolution, false );
	},
	
	start : function()
	{
	try{		
		if ( !CometMarksRoutine.isHasPrivilege() ) // do nothing
			return;
			
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");	
		
		// set time tick
		setInterval( "CometMarksKernelImpl.coreTimeTick();", 100 );
		
		// to monitor sync in every second
		setInterval( "CometMarksKernelImpl.monitorSync();", 1000 );
		
		// register observer
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver( CometMarksKernelObserver, CometMarksKernelObserverDefine.event_update, false );
		observerService.addObserver( CometMarksKernelObserver, CometMarksKernelObserverDefine.event_sync, false );
		observerService.addObserver( CometMarksKernelObserver, CometMarksKernelObserverDefine.event_overwrite, false );
		observerService.addObserver( CometMarksKernelObserver, CometPassportDefine.event_saved, false );

		// set file path
		var file = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get('ProfD', Components.interfaces.nsIFile);
		this.setPath( file.path );
	}catch(e){ CometMarksUtility.showCatchMessage( e ); }
	},
	
	coreTimeTick : function()
	{
		this._cometmarks.CoreTimeTick();
	},
	
	monitorSync : function()
	{
		var globalData = CometMarksGlobal.getGlobalData();
	
		// no login or logout
		if ( globalData.next_sync_time == null || globalData.next_sync_time == "N/A" )
			return;

		var now_time = new Date();
		var next_time = new Date( globalData.next_sync_time );
		if ( now_time >= next_time )
		{
			CometMarksGlobal.setData( CometMarksGlobalDefine.next_sync_time, "N/A" );
			write_log( "monitorSync: " + CometMarksUtility.getCurrentTime() );
			CometMarksKernel.synchronize();
		}
	},

	setPath : function( filePath )
	{
		this._cometmarks.SetPath( filePath );
	},
	
	release : function()
	{
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver( CometMarksKernelObserver, CometMarksRoutineDefine.event_devolution );
			
		if ( !CometMarksRoutine.isHasPrivilege() ) // do nothing
			return;
			
		// remove observer
		observerService.removeObserver( CometMarksKernelObserver, CometMarksKernelObserverDefine.event_update );
		observerService.removeObserver( CometMarksKernelObserver, CometMarksKernelObserverDefine.event_sync );
		observerService.removeObserver( CometMarksKernelObserver, CometMarksKernelObserverDefine.event_overwrite );
		observerService.removeObserver( CometMarksKernelObserver, CometPassportDefine.event_saved );
	}
};

window.addEventListener( "load", CometMarksKernelImpl.init, false );
window.addEventListener( "unload", CometMarksKernelImpl.release, false );