/* define cometmarks notes const variables */
if( typeof( CometMarksNotesDefined ) == "undefined" )
{
	try
	{
		eval('																						\r\n\
			const CometMarksNotesDefined =															\r\n\
			{																						\r\n\
				/* send event */ 																	\r\n\
				// 	note panels exchanged in different browser										\r\n\
				event_note_status				:	"cometmarks.notes.event.status",				\r\n\
				// 	note content changed															\r\n\
				event_note_changed				:	"cometmarks.notes.event.note_changed",			\r\n\
				/* status: close the panel */ 														\r\n\
				status_close					:	"cometmarks.notes.status.close"					\r\n\
			};																						\r\n\
		');
	} 
	catch( e ) 
	{
		alert ( e ); 
	}
}

////////////////////////////////////////////////////////////////
/* notes observer class */
var CometmarksNotesObserver =
{
	observe: function( subject, topic, data )
	{
		// get kernel state
		var kernelState = CometMarksKernel.getState();
		switch( topic )
		{
			case CometMarksKernelDefine.event_update :
			case CometMarksKernelDefine.event_sync :	
			case CometMarksKernelDefine.event_overwrite :	
				// success or no-record
				if ( kernelState.work_state == CometMarksKernelDefine.work_state_success || kernelState.work_state == CometMarksKernelDefine.work_state_no_record )
				{
					this.updateNotes();
				}
				break;
					
			case CometMarksKernelDefine.event_logout :
				this.closeNotes();
				break;
				
			case CometMarksNotesDefined.event_note_changed :
				// notify bookmarks note changed
				var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
				os.notifyObservers( null, CometMarksBookMarksDefine.event_note_changed, null );
				break;
				
			default :
				this.closeNotes();
				break;
		}
	},
	
	updateNotes : function()
	{
	try{
		// get server notes
		var server_notes = this.getServerNotes();
		server_notes = server_notes.replace(/\r\n/g, "\n");
		
		var local_notes = CometMarksKernel.getLocalNotes();
		local_notes = local_notes.replace(/\r\n/g, "\n");
		if ( server_notes != local_notes )
		{	
			// set local notes
			CometMarksKernel.setLocalNotes( server_notes );
		}

		// get local notes and save into the local array
		this.getAndSaveLocalNotes();
		
		// update the editing note
		this.updateEditingNote();
	}catch(e){write_log(e);}
	},
	
	getServerNotes : function()
	{
	try{
		var bookmarks_content = CometMarksKernel.getBookmarksContent();
		if ( bookmarks_content == "" )
			return "";
		
		var parser = new DOMParser();
		var xmlDoc = parser.parseFromString( bookmarks_content, "text/xml" );
			
		var oEvaluator = new XPathEvaluator();
		var sXPath = "/nodeset/node/children/node/guid";
		var oResult = oEvaluator.evaluate( sXPath, xmlDoc.documentElement, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null );
		if ( oResult == null )// don't find cometmarks note node
			return "";

		var elem_note = null;
		var oElement_note;
		var is_notes_exist = false;
		while ( oElement_note = oResult.iterateNext() ) 
		{
			if ( oElement_note.textContent == "BOOKMARK_NOTES" )
			{
				elem_note = oElement_note.parentNode;
				is_notes_exist = true;
				break;
			}
		}
		
		if ( !is_notes_exist )
			return "";
			
		sXPath = "./children/node";
		oResult = oEvaluator.evaluate( sXPath, elem_note, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null );
		if ( oResult == null ) // don't find note's content
			return "";
		
		// create local note xml
		var xmldoc = document.implementation.createDocument( "", "", null );
		var head = xmldoc.createProcessingInstruction( "xml", "version=\"1.0\"  encoding=\"UTF-8\" standalone=\"yes\"" );
		xmldoc.appendChild( head );
		var noteset = xmldoc.createElement( "noteset" );	
		
		var oElement;
		while ( oElement = oResult.iterateNext() )// save all notes into files
		{	
			var note_info = oElement.childNodes;	
			var note_data = new Object();

			for ( var j=0; j<note_info.length; j++ )
			{
				if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "guid" )
					note_data.guid = note_info[j].textContent;

				if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "type" )
					note_data.type = note_info[j].textContent;

				if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "name" )
					note_data.title = note_info[j].textContent;

				if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "content" )
					note_data.value = note_info[j].textContent;
			}
				  
			// save notes from xml
			var note = CometMarksBookMarks.createElementParent( xmldoc, noteset, "note" );
			CometMarksBookMarks.createElement( xmldoc, note, "guid", note_data.guid );
			CometMarksBookMarks.createElement( xmldoc, note, "type", note_data.type );
			CometMarksBookMarks.createElement( xmldoc, note, "name", note_data.title );
			CometMarksBookMarks.createElement( xmldoc, note, "content", note_data.value );
		}
		
		xmldoc.appendChild( noteset );
		
		var serializer = new XMLSerializer();
		var notes_xml_str = serializer.serializeToString(xmldoc);

		return notes_xml_str;
	}catch(e){write_log(e);}
	},
	
	getAndSaveLocalNotes : function()
	{
	try{
		// clear old data 
		while ( CometmarksNotesHandler._local_notes_data.length > 0 )
			CometmarksNotesHandler._local_notes_data.shift();	
			
		// get local notes
		var note_str = CometMarksKernel.getLocalNotes();
		note_str = note_str.replace( /\r\n/g, "\n" );
		
		// save into local array
		if ( note_str.length < 1 ) 
		{
			// add three empty note data
			var note_count = CometmarksNotesHandler._local_notes_data.length;
			while ( note_count < 1 ) // init with one empty note
			{
				var empty_note_data = new Object();
				empty_note_data.guid = CometMarksUtility.createGuid();
				empty_note_data.type = "note";
				empty_note_data.title = "Note";
				var now_time_str = new Date();
				empty_note_data.value = "";
				CometmarksNotesHandler._local_notes_data.push( empty_note_data );
				note_count++;
			}	
			return;
		}

		// anlyze note: convert str to dom struct
		var parser = new DOMParser();
		var doc = parser.parseFromString( note_str, "text/xml");
		 
		var noteset = doc.getElementsByTagName("noteset");
		var note_list = noteset[0].childNodes;
		for ( var i=0; i<note_list.length; i++ )
		{
			if ( note_list[i].nodeType == Node.ELEMENT_NODE )
			{
				var note_info = note_list[i].childNodes;
				var note_data = new Object();
				 
				for ( var j=0; j<note_info.length; j++ )
				{
					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "guid" )
						note_data.guid = note_info[j].textContent;

					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "type" )
						note_data.type = note_info[j].textContent;

					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "name" )
						note_data.title = note_info[j].textContent;

					if ( note_info[j].nodeType == Node.ELEMENT_NODE && note_info[j].tagName == "content" )
						note_data.value = note_info[j].textContent;
			  }
			  // save notes
			  CometmarksNotesHandler._local_notes_data.push( note_data );
			}
		}
	  
		// deal with loacl_notes_data array
		var note_count = CometmarksNotesHandler._local_notes_data.length;
		while ( note_count < 1 )// notes number less 3
		{
			var empty_note_data = new Object();
			empty_note_data.guid = CometMarksUtility.createGuid();
			empty_note_data.type = "note";
			empty_note_data.title = "CometMarks Note";
			var now_time_str = new Date();
			empty_note_data.value = "";
			CometmarksNotesHandler._local_notes_data.push( empty_note_data );
			note_count++;
		}
		
		// put the lastest in first
		CometmarksNotesHandler._local_notes_data.reverse();
	}catch(e){write_log(e);}
	},
	
	updateEditingNote : function()
	{
		var panel = document.getElementById( "cometmarks_note_panel" );
		if ( panel == null || panel.state != "open" )// not opened
			return;
		
		var server_note_data = null;
		var server_note_title = null;
		for ( var i=0; i<CometmarksNotesHandler._local_notes_data.length; i++ )
		{
			if ( CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].guid == CometmarksNotesHandler._local_notes_data[i].guid )
			{	
				server_note_data = CometmarksNotesHandler._local_notes_data[i].value;
				server_note_title = CometmarksNotesHandler._local_notes_data[i].title;
				break;
			}
		}
		
		// not find the note and detele it, then display the latest note
		if ( i == CometmarksNotesHandler._local_notes_data.length )
		{
			document.getElementById("panel_note_text").value = CometmarksNotesHandler._local_notes_data[0].value + "\n\n";
			document.getElementById("label_note_1").value = CometmarksNotesHandler._local_notes_data[0].value;
			
			CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].value = CometmarksNotesHandler._local_notes_data[0].value;
			CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].type = CometmarksNotesHandler._local_notes_data[0].type;
			CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].type = CometmarksNotesHandler._local_notes_data[0].type;
			CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].guid = CometmarksNotesHandler._local_notes_data[0].guid;
			
			return;
		}
		
		// the current note's content not be edited
		var current_note_content = document.getElementById("panel_note_text").value.replace(/\s+$/g, "");
		if ( CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].value == current_note_content )
		{
			// update note content
			if ( CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].value != server_note_data )
			{
				document.getElementById("panel_note_text").value = server_note_data + "\n\n";
				CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].value = server_note_data;
			}
			
			// update note title
			if ( CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title != server_note_title )
			{
				document.getElementById("label_note_1").value = server_note_title;
				CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title = server_note_title;
			}
		}
		else // has been edited
		{
			if ( current_note_content == server_note_data )
				return;
			
			// create a new note
			var new_note_data = new Object();
			new_note_data.guid = CometMarksUtility.createGuid();
			new_note_data.type = "note";
			new_note_data.title = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title;
			new_note_data.value = current_note_content;
			
			// save new note
			CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].guid = new_note_data.guid;
			CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].type = new_note_data.type;
			CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title = new_note_data.title;
			CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].value = new_note_data.value;
			
			// set local note and commit
			CometmarksNotesHandler.setLocalNotes( new_note_data );
		}
	},
	
	closeNotes : function()
	{
		CometmarksNotesHandler.notePanelDoclose( true );
	}
};

/////////////////////////////////////////////////////////
/* Notes Handl*/
var CometmarksNotesHandler = 
{
	/* all members */
	_is_real_popup				: false,
	_is_resize_select			: false,
	_is_panel_select			: false,
	
	_original_mouse_x			: 0,
	_original_mouse_y			: 0,
		
	_target_original_y			: 0,
	_target_original_x			: 0,
	_target_original_width		: 0,
	_target_original_height		: 0,
	
	_current_label_tab			: "label_note_1",
	_current_textbox_tab		: "",
	_current_label_id			: 0,
	
	_last_label_tab				: "",
	_last_label_id				: -1,
	_last_note_title			: "",
	_last_note_value			: "",
	
	_temp_notes_data 			: [],
	_local_notes_data			: [],
	
	/* all methods */
	init : function()
	{
		// register observer
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_update, false );
		observerService.addObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_sync, false );
		observerService.addObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_overwrite, false );
		observerService.addObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_logout, false );
		observerService.addObserver( CometmarksNotesObserver, CometMarksNotesDefined.event_note_changed, false );
	},
	
	release : function()
	{
		// remove observer
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_update );
		observerService.removeObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_sync );
		observerService.removeObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_overwrite );
		observerService.removeObserver( CometmarksNotesObserver, CometMarksKernelDefine.event_logout );
		observerService.removeObserver( CometmarksNotesObserver, CometMarksNotesDefined.event_note_changed );
	},
	
	showNotePanel : function()
	{
	try{	
		// for shot key
		if ( document.getElementById("cometmarks_show_note_menuitem").getAttribute("disabled") == "true" )
			return;

		var panel = document.getElementById( "cometmarks_note_panel" );
		if ( panel == null )
			return;
			
		if ( panel.state == "open" )// has opened
		{
			CometmarksNotesHandler.notePanelDoclose(true);
			return;
		}
		
		// close note panel
		var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		os.notifyObservers( null, CometMarksNotesDefined.event_note_status, CometMarksNotesDefined.status_close );
		
		// get last position
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = ps.getBranch("cometmarks.");
		var notes_dialog_x = prefs.getIntPref("notes_dialog.x");
		var notes_dialog_y = prefs.getIntPref("notes_dialog.y");
		var notes_dialog_width = prefs.getIntPref("notes_dialog.width");
		var notes_dialog_height = prefs.getIntPref("notes_dialog.height");
				
		if ( notes_dialog_x == 0 && notes_dialog_y == 0 )// original value
		{
			notes_dialog_x = ( window.screen.width - notes_dialog_width ) / 2;
			notes_dialog_y = ( window.screen.height - notes_dialog_height ) / 2;
		}
		
		// open panel
		this._is_real_popup = true;
		
		// init local data
		CometmarksNotesObserver.getAndSaveLocalNotes();	
		this._current_label_id = 0;
		panel.openPopupAtScreen( notes_dialog_x, notes_dialog_y, false );
		panel.sizeTo( notes_dialog_width, notes_dialog_height );
		
		// add event listener
		panel.addEventListener( "mousedown", CometmarksNotesHandler.panelMouseDown, false );
		panel.addEventListener( "mouseup", CometmarksNotesHandler.panelMouseUp, false ); 
		panel.addEventListener( "mousemove", CometmarksNotesHandler.panelMouseMove, false );
		panel.addEventListener( "mouseout", CometmarksNotesHandler.panelMouseOut, false );
	}catch(e){write_log(e);}
	},

	notePanelPopup : function()
	{		
		if ( !this._is_real_popup )
			return;
		this._is_real_popup = false;
		
		// clear old data 
		while ( CometmarksNotesHandler._temp_notes_data.length > 0 )
			CometmarksNotesHandler._temp_notes_data.shift();	
			
		// load notes data from CometmarksNotesHandler._local_notes_data
		var tab_data = new Object();
		tab_data.label_id = "label_note_1";
		tab_data.guid = CometmarksNotesHandler._local_notes_data[0].guid;
		tab_data.type = CometmarksNotesHandler._local_notes_data[0].type;
		tab_data.title = CometmarksNotesHandler._local_notes_data[0].title;
		tab_data.value = CometmarksNotesHandler._local_notes_data[0].value;		
		CometmarksNotesHandler._temp_notes_data.push( tab_data );
		
		// set note temp data
		if ( CometMarksGlobal.getGlobalData().current_note_guid != null )
		{
			for ( var i=0; i<CometmarksNotesHandler._temp_notes_data.length; i++ )
			{
				if ( CometmarksNotesHandler._temp_notes_data[i].guid == CometMarksGlobal.getGlobalData().current_note_guid )
				{
					CometmarksNotesHandler._temp_notes_data[i].value = CometMarksGlobal.getGlobalData().current_note_content;
					
					// reset global data
					CometMarksGlobal.setData( CometMarksGlobalDefine.current_note_guid, null );
					CometMarksGlobal.setData( CometMarksGlobalDefine.current_note_content, null );
					
					break;
				}
			}
		}
		
		// open label	
		this.noteSelectTab( null, this._current_label_tab );

		// set check state	
		//status bar	
		var note_statebar = document.getElementById("cometmarks_show_note_statebar");
		note_statebar.setAttribute( "checked", "true" );
		
		//menu
		var note_menu = document.getElementById("cometmarks_show_note_menuitem");
		note_menu.setAttribute( "checked", "true" );
	},

	notePanelClose : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
		
		CometmarksNotesHandler.notePanelDoclose( true );
	},
	
	setLocalNotes : function( note_data )
	{
	try{
		// check is new or old
		var is_new_note = true;
		var is_need_commit = false;
		
		// note_content max length 1024
		var note_content = note_data.value;
		if ( note_content.length > 10 * 1024 )
			note_content = note_content.substr(0, 10 * 1024);
		
		for ( var i=0; i<CometmarksNotesHandler._local_notes_data.length; i++ )
		{
			if ( note_data.guid == CometmarksNotesHandler._local_notes_data[i].guid )
			{
				if ( CometmarksNotesHandler._local_notes_data[i].type != note_data.type )
				{
					CometmarksNotesHandler._local_notes_data[i].type = note_data.type;
					is_need_commit = true;
				}

				if ( CometmarksNotesHandler._local_notes_data[i].title != note_data.title )
				{
					CometmarksNotesHandler._local_notes_data[i].title = note_data.title;
					is_need_commit = true;
				}

				if ( CometmarksNotesHandler._local_notes_data[i].value != note_content )
				{
					CometmarksNotesHandler._local_notes_data[i].value = note_content;
					is_need_commit = true;
				}

				is_new_note = false;
				break;
			}
		}

		// create xml
		var xmldoc = document.implementation.createDocument( "","",null );
		var head = xmldoc.createProcessingInstruction( "xml","version=\"1.0\"  encoding=\"UTF-8\" standalone=\"yes\"" );
		xmldoc.appendChild(head);
		var noteset = xmldoc.createElement("noteset");
		
		CometmarksNotesHandler._local_notes_data.reverse();
		for ( var i=0; i<CometmarksNotesHandler._local_notes_data.length; i++ )
		{
			var note = CometMarksBookMarks.createElementParent( xmldoc, noteset, "note" );
			CometMarksBookMarks.createElement( xmldoc, note, "guid", CometmarksNotesHandler._local_notes_data[i].guid );
			CometMarksBookMarks.createElement( xmldoc, note, "type", CometmarksNotesHandler._local_notes_data[i].type );
			CometMarksBookMarks.createElement( xmldoc, note, "name", CometmarksNotesHandler._local_notes_data[i].title );
			CometMarksBookMarks.createElement( xmldoc, note, "content", CometmarksNotesHandler._local_notes_data[i].value );
		}
		
		if ( is_new_note )
		{
		  // create new note element
		  var note = CometMarksBookMarks.createElementParent( xmldoc, noteset, "note" );
		  CometMarksBookMarks.createElement( xmldoc, note, "guid", note_data.guid );
		  CometMarksBookMarks.createElement( xmldoc, note, "type", note_data.type );
		  CometMarksBookMarks.createElement( xmldoc, note, "name", note_data.title );
		  CometMarksBookMarks.createElement( xmldoc, note, "content", note_content );
		  
		  CometmarksNotesHandler._local_notes_data.push( note_data );
		  is_need_commit = true;
		}
	  
		xmldoc.appendChild(noteset);
		CometmarksNotesHandler._local_notes_data.reverse();

		var serializer = new XMLSerializer();
		var str = serializer.serializeToString(xmldoc);
		
		// set local notes
		CometMarksKernel.setLocalNotes( str );
		
		if ( is_need_commit )
		{
			// notify to commit new note data
			var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
			os.notifyObservers( null, CometMarksNotesDefined.event_note_changed, null );
		}
	}catch(e){write_log(e);}
	},

	notePanelDoclose : function( is_real_close )
	{	
		// save size and position
		var panel = document.getElementById("cometmarks_note_panel");
		if ( panel == null || panel.state != "open" )
			return;
			
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = ps.getBranch("cometmarks.");
		prefs.setIntPref( "notes_dialog.x", panel.boxObject.screenX );
		prefs.setIntPref( "notes_dialog.y", panel.boxObject.screenY );
		prefs.setIntPref( "notes_dialog.width", panel.boxObject.width );
		prefs.setIntPref( "notes_dialog.height", panel.boxObject.height );
		
		// only hide panel
		if ( !is_real_close )
		{		
			// save temp note data
			for ( var i=0; i<CometmarksNotesHandler._local_notes_data.length; i++ )
			{
				if ( CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].guid == CometmarksNotesHandler._local_notes_data[i].guid )
				{
					CometmarksNotesHandler._local_notes_data[i].type = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].type;
					CometmarksNotesHandler._local_notes_data[i].title = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title;
					CometmarksNotesHandler._local_notes_data[i].value = document.getElementById("panel_note_text").value;
					break;
				}
			}
			
			// hide panel
			panel.hidePopup();
			return;
		}
		
		// save all notes to xml file
		var note_data = new Object();
		note_data.guid = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].guid;
		note_data.type = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].type;
		note_data.title = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title;
		note_data.value = document.getElementById("panel_note_text").value;
		
		// trim
		note_data.value = note_data.value.replace(/\s+$/g, "");
		// reset note
		document.getElementById("panel_note_text").value = note_data.value + "\n\n";
		
		// save and notify
		this.setLocalNotes( note_data );
			
		// remove check state
		var note_statebar = document.getElementById("cometmarks_show_note_statebar");
		note_statebar.removeAttribute( "checked" );
		
		var note_menu = document.getElementById("cometmarks_show_note_menuitem");
		note_menu.removeAttribute( "checked" );
		
		// remove event listener
		panel.removeEventListener( "mousedown", CometmarksNotesHandler.panelMouseDown, false );
		panel.removeEventListener( "mouseup", CometmarksNotesHandler.panelMouseUp, false ); 
		panel.removeEventListener( "mousemove", CometmarksNotesHandler.panelMouseMove, false );
		panel.removeEventListener( "mouseout", CometmarksNotesHandler.panelMouseOut, false );
		
		// close panel
		panel.hidePopup();
	},

	// about panel move
	panelMouseDown : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.target.id == "note_close_image" )// close note
		{
			// change close picture
			document.getElementById("note_close_image").setAttribute( "status", "mousein" );
			return;
		}
		
		if ( event.target.id == "note_cut_image" && event.target.getAttribute("usable")== "1" )// cut note
		{
			// change cut picture
			document.getElementById("note_cut_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_copy_image" && event.target.getAttribute("usable")== "1" )// copy note
		{
			// change copy picture
			document.getElementById("note_copy_image").setAttribute( "status", "mousedown" );
			return;
		}
		
		if ( event.target.id == "note_paste_image" && event.target.getAttribute("usable")== "1" )// paste note
		{
			// change paste picture
			document.getElementById("note_paste_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_save_image" && event.target.getAttribute("usable")== "1" )// save note
		{
			// change save picture
			document.getElementById("note_save_image").setAttribute( "status", "able" );
			return;
		}
		
		var panel = document.getElementById("cometmarks_note_panel");
		if ( event.target.id == "note_bottom_right_image" )// change note size
		{
			this._is_resize_select = true;
			this._original_mouse_x = event.screenX;
			this._original_mouse_y = event.screenY;
			this._target_original_width = panel.boxObject.width;
			this._target_original_height = panel.boxObject.height;
			return;
		}
		
		if ( event.target.getAttribute( "movable" ) != "1" )
			return;
		
		this._is_panel_select = true;
			
		// save current position	
		this._original_mouse_x = event.screenX;
		this._original_mouse_y = event.screenY;

		this._target_original_x = panel.boxObject.screenX + window.screen.availLeft;
		this._target_original_y = panel.boxObject.screenY + window.screen.availTop;
	},

	panelMouseMove : function( event )
	{
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		if ( event.target.id == "note_close_image" )
		{
			// change close picture
			document.getElementById("note_close_image").setAttribute( "status", "mouseover" );
			document.getElementById("note_close_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.close");
			return;
		}
		
		if ( event.target.id == "note_cut_image" )// cut note
		{
			document.getElementById("note_cut_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.cut");
			
			// change cut picture
			if ( event.target.getAttribute("usable")== "1" )
				document.getElementById("note_cut_image").setAttribute( "status", "mouseover" );
			
			return;
		}
		
		if ( event.target.id == "note_copy_image"  )// copy note
		{
			document.getElementById("note_copy_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.copy");
			
			// change copy picture
			if ( event.target.getAttribute("usable")== "1" )
				document.getElementById("note_copy_image").setAttribute( "status", "mouseover" );
			
			return;
		}
		
		if ( event.target.id == "note_paste_image" )// paste note
		{
			document.getElementById("note_paste_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.paste");
			
			// change paste picture
			if ( event.target.getAttribute("usable")== "1" )
				document.getElementById("note_paste_image").setAttribute( "status", "mouseover" );
			
			return;
		}
		
		if ( event.target.id == "note_save_image" )// save note
		{
			document.getElementById("note_save_image").tooltipText = bubble.GetStringFromName("cometmarks.notes.save");
			
			// change save picture
			if ( event.target.getAttribute("usable")== "1" )
				document.getElementById("note_save_image").setAttribute( "status", "mouseover" );
			
			return;
		}
		
		if ( event.target.id == "note_bottom_right_image" )// change resize curor
		{
			event.target.setAttribute( "style", "cursor: nwse-resize;" );
		}
		
		if ( this._is_resize_select )
		{
			var deltaX = event.screenX - this._original_mouse_x;
			var deltaY = event.screenY - this._original_mouse_y;
			var panel = document.getElementById("cometmarks_note_panel");
			panel.sizeTo( this._target_original_width + deltaX,  this._target_original_height + deltaY );
			return;
		}
		
		if ( !this._is_panel_select )
			return;

		var del_x = event.screenX - this._original_mouse_x;
		var del_y = event.screenY - this._original_mouse_y;
		
		var dx = event.screenX - event.clientX;
		var dy = event.screenY - event.clientY;
		
		var panel = document.getElementById("cometmarks_note_panel");
		if ( panel == null )
			return;
			
		panel.moveTo( this._target_original_x + dx + del_x, this._target_original_y + dy + del_y );
	},

	panelMouseUp : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.target.id == "note_close_image" )
		{
			// change close picture
			document.getElementById("note_close_image").setAttribute( "status", "mouseout" );
			return;
		}
		
		if ( event.target.id == "note_cut_image" && event.target.getAttribute("usable")== "1" )// cut note
		{
			// change cut picture
			document.getElementById("note_cut_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_copy_image" && event.target.getAttribute("usable")== "1" )// copy note
		{
			// change copy picture
			document.getElementById("note_copy_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_paste_image" && event.target.getAttribute("usable")== "1" )// paste note
		{
			// change paste picture
			document.getElementById("note_paste_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_save_image" && event.target.getAttribute("usable")== "1" )// save note
		{
			// change save picture
			document.getElementById("note_save_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( this._is_resize_select )
		{
			this._is_resize_select = false;
			return;
		}
		
		if ( !this._is_panel_select )
			return;

		this._is_panel_select = false;

		var del_x = event.screenX - this._original_mouse_x;
		var del_y = event.screenY - this._original_mouse_y;
		
		if ( del_x == 0 && del_y == 0 ) // not move
			return;
		
		// only call panel.hidePopup();
		CometmarksNotesHandler.notePanelDoclose( false ); 
		
		var panel = document.getElementById("cometmarks_note_panel");
		if ( panel == null )
			return;
			
		var screenx = this._target_original_x + del_x - window.screen.availLeft;
		if ( screenx + panel.boxObject.width > window.screen.availWidth -window.screen.availLeft - 3 )
		{
			screenx = window.screen.availWidth - panel.boxObject.width - window.screen.availLeft - 3;
		}

		var screeny = this._target_original_y + del_y - window.screen.availTop;
		if ( screeny + panel.boxObject.height > window.screen.availHeight -window.screen.availTop - 3 )
		{
			screeny = window.screen.availHeight - panel.boxObject.height - window.screen.availTop - 3;
		}
			
		this._is_real_popup = true;
		
		panel.openPopupAtScreen( screenx, screeny, false );
		var ps = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = ps.getBranch("cometmarks.");
		panel.sizeTo( prefs.getIntPref("notes_dialog.width"), prefs.getIntPref("notes_dialog.height") );
	},

	panelMouseOut : function( event )
	{
		if ( event.target.id == "note_close_image" )
		{
			// change close picture
			document.getElementById("note_close_image").setAttribute( "status", "mouseout" );
		}
		
		if ( event.target.id == "note_cut_image" && event.target.getAttribute("usable")== "1" )// cut note
		{
			// change cut picture
			document.getElementById("note_cut_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_copy_image" && event.target.getAttribute("usable")== "1" )// copy note
		{
			// change copy picture
			document.getElementById("note_copy_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_paste_image" && event.target.getAttribute("usable")== "1" )// paste note
		{
			// change paste picture
			document.getElementById("note_paste_image").setAttribute( "status", "able" );
			return;
		}
		
		if ( event.target.id == "note_save_image" && event.target.getAttribute("usable")== "1" )// save note
		{
			// change save picture
			document.getElementById("note_save_image").setAttribute( "status", "able" );
			return;
		}
	},

	noteSelectTab : function( event, id )
	{			
		if ( event == null )
		{
			this._current_label_tab = id;
		}
		else
		{
			if ( event.button != 0 )// not left button
				return;
				
			if ( event.detail > 1 )// db-click
				return;
				
			if ( this._current_label_tab ==  event.target.id )
				return;
				
			this._current_label_tab =  event.target.id;
		}
		
		CometmarksNotesHandler._current_label_id = 0;
		if ( this._current_label_tab == "label_note_1" )
		{		
			// set note content and title
			var note_content = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].value.replace(/\s+$/g, "");
			if ( note_content.length > 0)
				document.getElementById("panel_note_text").value = note_content + "\n\n";
			else
				document.getElementById("panel_note_text").value = "";
				
			if ( CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title.length > 0 )
			{
				document.getElementById("label_note_1").value = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title;
			}
			else
			{
				document.getElementById("label_note_1").value = "Note";
				CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title = "Note";
			}
				
			// set font 
			document.getElementById("label_note_1").setAttribute( "style", "font-weight: bold; text-align:center;" );
			document.getElementById("label_note_2").setAttribute( "style", "font-weight: normal; text-align:center;" );
			document.getElementById("label_note_3").setAttribute( "style", "font-weight: normal; text-align:center;" );
			
			// set background
			document.getElementById("note_bg_left1").setAttribute( "status", "show" );
			document.getElementById("label_note_div1_1").setAttribute( "style", "background-image: url('chrome://cometmarks/skin/buttons/notes-label-bg-center.png')" );
			document.getElementById("note_bg_right1").setAttribute( "status", "show");
			document.getElementById("note_bg_right1").setAttribute( "hidden", "false" );
			
			document.getElementById("note_bg_left2").setAttribute( "hidden", "true" );
			document.getElementById("label_note_div2_1").setAttribute( "style", "background-image:url('chrome://cometmarks/skin/buttons/notes-label-bg-center-replace.png')" );
			document.getElementById("note_bg_right2").setAttribute( "hidden", "true" );
			
			document.getElementById("note_bg_left3").setAttribute( "hidden", "false" );
			document.getElementById("note_bg_left3").setAttribute( "status", "hide" );
			document.getElementById("label_note_div3_1").setAttribute( "style", "background-image:url('chrome://cometmarks/skin/buttons/notes-label-bg-center-replace.png')" );
			document.getElementById("note_bg_right3").setAttribute( "status", "hide" );
			
			// set div position
			document.getElementById("label_note_div1").setAttribute( "style", "margin-top: -6px;" );
			document.getElementById("label_note_div2").setAttribute( "style", "margin-top: -5px;" );
			document.getElementById("label_note_div3").setAttribute( "style", "margin-top: -5px;" );
			
			document.getElementById("panel_note_text").focus();
		}
	},

	noteEditTab : function( event )// db click
	{
		if ( event.button != 0 )// not left button
			return;
				
		// show note-textbox
		if ( event.target.id == "label_note_1" )
		{
			var note_label_1 = document.getElementById("label_note_1");
			note_label_1.setAttribute( "hidden", "true" );

			document.getElementById("label_note_div1_11").setAttribute( "style", "margin-top: -4px;" );
			var note_box = document.getElementById("textbox_note_1");
			note_box.setAttribute( "hidden", "false" );
			note_box.setAttribute( "style", " -moz-appearance: none; border: none; text-align:center; color:black; background-color:transparent;" );
			note_box.value = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title;
			this._last_note_title = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title;
			note_box.select();
						
			this._current_textbox_tab = "textbox_note_1";
		}
	},

	saveNoteTitle : function()
	{
		// hidden note-textbox
		var note_box = document.getElementById( this._current_textbox_tab );
		note_box.setAttribute( "hidden", "true" );
			
		// show note-label
		document.getElementById("label_note_div1_11").setAttribute( "style", "margin-top: 0px;" );
		document.getElementById( this._current_label_tab ).setAttribute( "value", note_box.value );
		document.getElementById( this._current_label_tab ).setAttribute( "hidden", "false" );
		document.getElementById( this._current_label_tab ).setAttribute( "style", "font-weight: bold; text-align:center;" );
		
		if ( this._last_note_title == note_box.value )
			return;
			
		// save note title 
		CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title = note_box.value;
		
		var note_data = new Object();
		note_data.guid = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].guid;
		note_data.type = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].type;
		note_data.title = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title;
		note_data.value = document.getElementById("panel_note_text").value;
		
		// save and notify
		this.setLocalNotes( note_data );
	},
	
	noteSave : function( event )
	{	
		if ( event.target.getAttribute("usable") != "1" )
			return;
			
		// save all notes
		CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].value = document.getElementById("panel_note_text").value;
		
		var note_data = new Object();
		note_data.guid = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].guid;
		note_data.type = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].type;
		note_data.title = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].title;
		note_data.value = CometmarksNotesHandler._temp_notes_data[CometmarksNotesHandler._current_label_id].value;
		
		// trim
		note_data.value = note_data.value.replace(/\s+$/g, "");
		// reset note
		document.getElementById("panel_note_text").value = note_data.value + "\n\n";
		
		// save and notify
		this.setLocalNotes( note_data );
		
		document.getElementById("note_save_image").setAttribute("status", "disabled" );		
		document.getElementById("note_save_image").setAttribute("usable", "0" );
	},
	
	noteCut : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.target.getAttribute("usable") != "1" )
			return;
			
		var aCommand = "cmd_cut";
		goDoCommand( aCommand );
		
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_cut_image").setAttribute("status", "able" );
			document.getElementById("note_cut_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_cut_image").setAttribute("status", "disabled" );
			document.getElementById("note_cut_image").setAttribute("usable", "0" );
		}
	},

	noteCopy : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.target.getAttribute("usable") != "1" )
			return;
			
		var aCommand = "cmd_copy";
		goDoCommand( aCommand );
		
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_copy_image").setAttribute("status", "able" );
			document.getElementById("note_copy_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_copy_image").setAttribute("status", "disabled" );
			document.getElementById("note_copy_image").setAttribute("usable", "0" );
		}
	},

	notePaste : function( event )
	{
		if ( event.button != 0 )// not left button
			return;
			
		if ( event.target.getAttribute("usable") != "1" )
			return;
			
		var aCommand = "cmd_paste";
		goDoCommand( aCommand );
		
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_paste_image").setAttribute("status", "able" );
			document.getElementById("note_paste_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_paste_image").setAttribute("status", "disabled" );
			document.getElementById("note_paste_image").setAttribute("usable", "0" );
		}
	},
	
	input : function( event )
	{
		if ( event.target.id != "panel_note_text" )
			return;
	
		document.getElementById("note_save_image").setAttribute("status", "able" );		
		document.getElementById("note_save_image").setAttribute("usable", "1" );	
	},
	
	keyup : function( obj )
	{
		var mlength = obj.getAttribute ? parseInt( obj.getAttribute("maxlength") ) : "";
		if ( obj.getAttribute && obj.value.length > mlength)
			obj.value = obj.value.substring( 0, mlength );
	},
	
	updateCut : function()
	{
		var aCommand = "cmd_cut";	
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_cut_image").setAttribute("status", "able" );
			document.getElementById("note_cut_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_cut_image").setAttribute("status", "disabled" );
			document.getElementById("note_cut_image").setAttribute("usable", "0" );
		}
	},

	updateCopy : function()
	{			
		var aCommand = "cmd_copy";
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_copy_image").setAttribute("status", "able" );
			document.getElementById("note_copy_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_copy_image").setAttribute("status", "disabled" );
			document.getElementById("note_copy_image").setAttribute("usable", "0" );
		}
	},
	
	updatePaste : function()
	{
		var aCommand = "cmd_paste";
		var controller = document.getElementById("panel_note_text").controllers.getControllerForCommand( aCommand );
		if( controller && controller.isCommandEnabled( aCommand ) ) 
		{
			document.getElementById("note_paste_image").setAttribute("status", "able" );
			document.getElementById("note_paste_image").setAttribute("usable", "1" );
		}
		else
		{
			document.getElementById("note_paste_image").setAttribute("status", "disabled" );
			document.getElementById("note_paste_image").setAttribute("usable", "0" );
		}
	}
};

window.addEventListener( "load", CometmarksNotesHandler.init, false );
window.addEventListener( "unload", CometmarksNotesHandler.release, false );