﻿/* deal with replace bookmarks */
var ReplaceBookMarksHandler = 
{
	// members
	_bookmarksService 	: Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService),
	
	/* all methods*/
	checkReplace : function()
	{
		// init status
		var replace_menu = document.getElementById("cometmarks_replace_menu");
		replace_menu.setAttribute("disabled", true);			
		CometMarksGlobal.setData( CometMarksGlobalDefine.current_tab_guid, null );
		
		var cometmarks_guid = null;
		var currentTab = gBrowser.getBrowserAtIndex( gBrowser.mTabContainer.selectedIndex );
		
		// check current url
		if ( currentTab.currentURI.spec == "about:blank" || currentTab.currentURI.host == null || currentTab.currentURI.host.length == 0 )
		{
			return;
		}
		
		if ( this._bookmarksService.isBookmarked(currentTab.currentURI) )
		{
			return; 
		}
		
		cometmarks_guid = currentTab.getAttribute("cometmarks_guid");
		// cometmarks_guid is null or invalid
		if (cometmarks_guid == null || cometmarks_guid.length == 0)
		{
			currentTab.setAttribute("cometmarks_guid", null);
			return;
		}	
    
		// the bookmarks with cometmarks_guid is delete before
		var bookitem_id = this._bookmarksService.getItemIdForGUID(cometmarks_guid);
		if (bookitem_id == -1)
		{
			currentTab.setAttribute("cometmarks_guid", null);
			return;
		}
  	
		// url is the same with original_url
		var original_uri = this._bookmarksService.getBookmarkURI(bookitem_id); 
		if ( currentTab.currentURI.spec == original_uri.spec )
		{
			return;
		}
			
		// now replace menu can used
		CometMarksGlobal.setData( CometMarksGlobalDefine.current_tab_guid, cometmarks_guid );
		replace_menu.setAttribute("disabled", false);
	},
	
	showReplacePanel : function()
	{
		// open panel
		var browser = gBrowser.selectedTab;
		var panel = document.getElementById("cometmarks_replace_panel");

		var pX = browser.boxObject.screenX;
		var full_x = window.innerWidth;
		var window_width = 280;
		if ( pX + window_width > full_x )
		{
			panel.openPopup(browser, "after_end", 0, 0, false, false);
		}
		panel.openPopup(browser, "after_start", 0, 0, false, false);
	},
	
	panelPopup : function()
	{
		// init panel
		var currentTab = gBrowser.getBrowserAtIndex( gBrowser.mTabContainer.selectedIndex );	 

		document.getElementById("cometmarks_replace_newtitle").value = currentTab.contentTitle;
		document.getElementById("cometmarks_replace_newurl").value = currentTab.currentURI.spec;
		
		var globalData = CometMarksGlobal.getGlobalData();
		var bookitem_id = this._bookmarksService.getItemIdForGUID( globalData.current_tab_guid );
		var old_title = this._bookmarksService.getItemTitle( bookitem_id );
		var old_url = this._bookmarksService.getBookmarkURI( bookitem_id ).spec;
	  
		document.getElementById("cometmarks_replace_oldtitle").value = old_title;
		document.getElementById("cometmarks_replace_olrurl").value = old_url;
		
		// set focus
		document.getElementById('cometmarks_replace_newtitle').select();
		document.getElementById('cometmarks_replace_newtitle').focus();
	},
	
	replaceOnOk : function()
	{
		// get bookmark item id by cometmarks_guid
		var replace_menu = document.getElementById("cometmarks_replace_menu");

		// get globalData
		var globalData = CometMarksGlobal.getGlobalData();
		var bookitem_id = this._bookmarksService.getItemIdForGUID( globalData.current_tab_guid );
		if ( bookitem_id == -1 )
		{
			replace_menu.setAttribute( "disabled", true );
			document.getElementById( "cometmarks_replace_panel" ).hidePopup();
			return;
		}
			
		// set new url
		var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var new_url = document.getElementById("cometmarks_replace_newurl").value;
		var uri = ios.newURI( new_url, null, null );
		this._bookmarksService.changeBookmarkURI( bookitem_id, uri );
		
		// set new title
		var new_title = document.getElementById("cometmarks_replace_newtitle").value; // save it when changed first
		if ( new_title.length == 0 )
			new_title = new_url;
		this._bookmarksService.setItemTitle( bookitem_id, new_title );
		write_log("=finish repalce title and url for old bookmark");
			
		// set replace button disabled
		replace_menu.setAttribute("disabled", true);
		document.getElementById("cometmarks_replace_panel").hidePopup();
	},
	
	replaceOnCancel : function()
	{
		document.getElementById("cometmarks_replace_panel").hidePopup();
	},
	
	replaceKeyEnter : function( event )
	{
		var evt = event || window.event;
		if ( evt.keyCode == 13 )// enter key
		{
			this.replaceOnOk();
		}
	}
};
