﻿/* update setting ui state */
var SettingStateObserver =
{
	timer 							: null,
	cometmarks_connect_failed		: false,
	
	observe: function( subject, topic, data )
	{
		switch( topic )
		{
			case CometMarksKernelDefine.event_update :
			case CometMarksKernelDefine.event_sync :
			case CometMarksKernelDefine.event_overwrite :
			case CometMarksKernelDefine.event_logout :
			case CometMarksKernelDefine.event_bookmarks_changed :
				this.updateSettingState();
				break;
				
			default :
				break;
		}
	},
	
	updateSettingState : function()
	{
		// get ui object
		var state_image = document.getElementById("general_status_image");
		var state_text = document.getElementById("general_status_static");

		var has_change = document.getElementById("general_status_has_change");
		var change_time = document.getElementById("general_status_synctime");
		var submit_time = document.getElementById("general_status_submittime");

		var lastsync_time = document.getElementById("general_lastsync_static");

		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		
		// get state
		var globalData = CometMarksGlobal.getGlobalData();
		var kernelState = CometMarksKernel.getState();
		var workState = kernelState.work_state;
		window.clearTimeout( this.timer );
		
		// clear connetting
		state_image.setAttribute("src", "");
		submit_time.setAttribute("value", kernelState.bookmarks_datetime );
		
		if ( CometMarksKernelDefine.work_state_syncing == workState )
		{
			state_image.setAttribute("src", "chrome://cometmarks/skin/state_connecting_32.gif");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.syncing"));
			change_time.setAttribute("value", "N/A");
			return;
		}
		
		if ( CometMarksKernelDefine.work_state_updating == workState )
		{
			state_image.setAttribute("src", "chrome://cometmarks/skin/state_connecting_32.gif");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.updating"));
			change_time.setAttribute("value", "N/A");
			return;
		}
		
		if ( CometMarksKernelDefine.work_state_success == workState )
		{
			state_image.setAttribute("status", "ok");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.success"));
			var time = CometMarksUtility.formatGmtTime( globalData.last_sync_time );
			lastsync_time.setAttribute("value", time);
			has_change.setAttribute("value", "N/A");
			this.cometmarks_connect_failed = false;
			this.timer = window.setInterval( "SettingStateObserver.changeTimer();",1000 );
			return;
		}
		
		if ( CometMarksKernelDefine.work_state_changed == workState )
		{
			state_image.setAttribute("status", "pending");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.wait"));
			has_change.setAttribute("value", bubble.GetStringFromName("cometmarks.status.bookmark.changed"));
			this.cometmarks_connect_failed = false;
			this.timer = window.setInterval( "SettingStateObserver.changeTimer();", 1000 );
			return;
		}
		
		if ( CometMarksKernelDefine.work_state_invalid_password == workState )
		{
			state_image.setAttribute("status", "failed");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.invalid.password"));
			change_time.setAttribute("value", "N/A");
			submit_time.setAttribute("value", "N/A" );
			return;
		}
		
		if ( CometMarksKernelDefine.work_state_out_of_date == workState )
		{
			state_image.setAttribute("status", "failed");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.out.of.date"));
			change_time.setAttribute("value", "N/A");
			submit_time.setAttribute("value", "N/A" );
			return;
		}
		
		if ( CometMarksKernelDefine.work_state_connect_failed == workState )
		{
			state_image.setAttribute("status", "failed");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.connect.failed"));
			
			var time = CometMarksUtility.formatGmtTime( globalData.last_sync_time );
			lastsync_time.setAttribute("value", time);
			change_time.setAttribute("value", "N/A");
			this.cometmarks_connect_failed = true;
			this.timer = window.setInterval("SettingStateObserver.changeTimer();",1000);
			return;
		}
		
		if ( CometMarksKernelDefine.work_state_no_record == workState )
		{
			state_image.setAttribute("status", "ok");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.success"));
			lastsync_time.setAttribute("value", "N/A");
			has_change.setAttribute("value", "N/A");
			submit_time.setAttribute("value", "N/A" );
			this.cometmarks_connect_failed = false;
			this.timer = window.setInterval("SettingStateObserver.changeTimer();",1000);
			return;
		}
		
		if ( CometMarksKernelDefine.work_state_overwriting == workState )
		{
			state_image.setAttribute("src", "chrome://cometmarks/skin/state_connecting_32.gif");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.overwriting"));
			change_time.setAttribute("value", "N/A");
			return;
		}
		
		if ( CometMarksKernelDefine.work_state_no_login == workState )
		{
			state_image.setAttribute("status", "logout");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.no.login"));
			lastsync_time.setAttribute("value", "N/A");
			change_time.setAttribute("value", "N/A");
			has_change.setAttribute("value", "N/A");
			submit_time.setAttribute("value", "N/A" );
			return;
		}
		
		if ( CometMarksKernelDefine.work_state_exception == workState )
		{
			state_image.setAttribute("status", "failed");
			state_text.setAttribute("value", bubble.GetStringFromName("cometmarks.status.exception"));
			change_time.setAttribute("value", "N/A");
		}
	},
	
	// change time in setting ui interval one second
	changeTimer : function()
	{
		var change_time = document.getElementById("general_status_synctime");
		var globalData = CometMarksGlobal.getGlobalData();

		var begin_time = null;
		if ( this.cometmarks_connect_failed )
			begin_time = CometMarksUtility.getSecondsFromTimeStr( globalData.last_failed_time );
		else	
			begin_time = CometMarksUtility.getSecondsFromTimeStr( globalData.last_sync_time );
			
		var now = new Date();
		var now_time = CometMarksUtility.getSecondsFromTimeStr( now.toGMTString() );
		if ( now_time < begin_time )// i.e. now: 17:01:02  begin: 16:59:21
			now_time += 3600;
			
		var offset = now_time - begin_time;
		var autosync_interval_sec = CometMarksUtility.getAutosyncIntervalSec();
		var minimum_sync_interval_sec = CometMarksUtility.getMinimumSyncIntervalSec();

		if ( !globalData.is_bookmarks_changeded )
		{
			if ( offset > autosync_interval_sec - 1 )
			{
				window.clearTimeout( this.timer );
				if (change_time != "undefined")
					change_time.setAttribute("value", "N/A");
				return;
			}

			var left_time = autosync_interval_sec - offset;
			var minute = "0" + Math.floor( left_time / 60);
			
			var second = "";
			if ( left_time % 60 < 10 )
				second += "0";
			second += left_time % 60;
			
			var left = minute + " : " + second;
			if ( change_time != "undefined" )
				change_time.setAttribute("value", left);
			return;
		}

		if ( offset > minimum_sync_interval_sec - 1 || offset < 1 )
		{
			window.clearTimeout( this.timer );
			if (change_time != "undefined")
				change_time.setAttribute("value", "N/A");
			return;
		}

		var left = "";
		if ( minimum_sync_interval_sec - offset < 10 )
			left += "0";
		left += minimum_sync_interval_sec - offset;
		
		var times_str = "00 : " + left;
		if ( change_time != "undefined" )
			change_time.setAttribute("value", times_str);
	}
};

/* deal with setting xul */
var CometmarksSettingHandler = 
{
	/* all methods */
	doLoad : function()
	{
	try{
		// set the window type name
		document.documentElement.setAttribute("windowtype", "CometMarksSettingDialog");

		// add observer
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver( SettingStateObserver, CometMarksKernelDefine.event_update, false );
		observerService.addObserver( SettingStateObserver, CometMarksKernelDefine.event_sync, false );
		observerService.addObserver( SettingStateObserver, CometMarksKernelDefine.event_overwrite, false );
		observerService.addObserver( SettingStateObserver, CometMarksKernelDefine.event_logout, false );
		observerService.addObserver( SettingStateObserver, CometMarksKernelDefine.event_bookmarks_changed, false );
		
		// get globalData
		var globalData = CometMarksGlobal.getGlobalData();
		
		// get kernel state
		var kernelState = CometMarksKernel.getState();
		var workState = kernelState.work_state;

		// set init value
		var time = CometMarksUtility.formatGmtTime( globalData.last_sync_time );
		document.getElementById("general_lastsync_static").value = time;
		var has_change = document.getElementById("general_status_has_change");
		var change_time = document.getElementById("general_status_synctime");
		var submit_time = document.getElementById("general_status_submittime");
		has_change.setAttribute("value", "N/A");
		change_time.setAttribute("value", "N/A");
		submit_time.setAttribute("value", "N/A" );

		// update the status for myself
		SettingStateObserver.updateSettingState();
		
		// show general panel when loaded
		var general_pane = document.getElementById("setting_general_panel");
		document.getElementById("cometmarks_settings").showPane( general_pane );
		
		// show left sync time now
		if ( workState == CometMarksKernelDefine.work_state_changed || workState == CometMarksKernelDefine.work_state_success 
			|| workState == CometMarksKernelDefine.work_state_connect_failed || workState == CometMarksKernelDefine.work_state_no_record )
		{
			SettingStateObserver.changeTimer();
		}

		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = prefService.getBranch("cometmarks.");

		// enable logging
		var enable_logs = prefs.getBoolPref("enable_logs");
		if ( enable_logs )
			document.getElementById("general_enablelogging_checkbox").setAttribute("checked", "true");
		else
			document.getElementById("general_enablelogging_checkbox").setAttribute("checked", "false");
			
		// get username and password		
		var aUsername = CometPassport.getUsername();
		var aPassword = CometPassport.getPassword();	
		if ( aUsername == "" )
		{
			document.getElementById("general_username_editbox").focus();
			document.getElementById("general_username_editbox").select();
			return;
		}
		else
			document.getElementById("general_username_editbox").value = aUsername;
			
		if ( aPassword == "" )
		{
			document.getElementById("general_password_editbox").focus();
			document.getElementById("general_password_editbox").select();
			return;
		}
		else
		{
			if ( prefs.getBoolPref("autologin") )
			{
				document.getElementById("general_autologin_checkbox").setAttribute("checked", "true");
				document.getElementById("general_password_editbox").value = aPassword;
			}
			else
			{
				document.getElementById("general_password_editbox").value = "";
				document.getElementById("general_autologin_checkbox").setAttribute("checked", "false");
			}
		}
	}catch(e){write_log(e);}
	},
	
	// sync the bookmarks
	synchronize : function()
	{
	try{
		// get username and password from ui
		var aUsername = document.getElementById("general_username_editbox").value;
		var aPassword = document.getElementById("general_password_editbox").value;
	
		// get username and password from cometpassport
		var g_username = CometPassport.getUsername();
		var g_password = CometPassport.getPassword();
		
		// to check overwrite dialog
		var overwrite_win = CometMarksUtility.getWindowByType("CometMarksOverwriteDialog");
		// has opened
		if ( overwrite_win && aUsername == g_username && aPassword == g_password )
		{
			overwrite_win.focus();
			return;
		}

		if ( aUsername == "" )
		{
			// select the username 
			document.getElementById("general_username_editbox").focus();
			document.getElementById("general_username_editbox").select();
			return;
		}
		
		if ( aPassword == "")
		{
			document.getElementById("general_password_editbox").focus();
			document.getElementById("general_password_editbox").select();
			return;
		}
	
		// get state
		var kernelState = CometMarksKernel.getState();
		if ( kernelState.is_login && g_username == aUsername && g_password == aPassword )
		{	
			// go to sync
			CometMarksKernel.synchronize();
		}
		else
		{
			// logout first
			CometMarksKernel.logOut();

			// set passport username
			CometPassport.setUsername( aUsername, aPassword );
		}
		
		// set auto login
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = prefService.getBranch("cometmarks.");
		if ( document.getElementById("general_autologin_checkbox").checked )
			prefs.setBoolPref("autologin", true);
		else
			prefs.setBoolPref("autologin", false);
				
	}catch(e){write_log(e);}
	},
	
	// change the accout
	doOk : function()
	{
	try{
		// get username and password from ui
		var aPassword = document.getElementById("general_password_editbox").value;
		var aUsername = document.getElementById("general_username_editbox").value;
		
		// get username and password from cometpassport
		var g_username = CometPassport.getUsername();
		var g_password = CometPassport.getPassword();
		
		// get overwrite dialog
		var overwrite_win = CometMarksUtility.getWindowByType( "CometMarksOverwriteDialog" );
		
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var message = "";

		if ( aUsername == "" && aPassword == "" ) // both username and password are null
		{	
			message = bubble.GetStringFromName("cometmarks.sign.out");	
			if ( window.confirm(message) )// has logined and want to exit
			{ 
				// logout
				CometMarksUtility.getCometMarksLogout();
				return true;
			}
			else // cancel, accout doesn't exit login
			{
				return false;
			}
		}
		
		if ( aUsername == "" )
		{
			message = bubble.GetStringFromName("cometmarks.sign.username");
			alert(message);
			document.getElementById("general_username_editbox").focus();
			document.getElementById("general_username_editbox").select();
			return false;
		}
	
		if ( aPassword == "" )
		{				
			message = bubble.GetStringFromName("cometmarks.sign.password");
			alert(message);
			document.getElementById("general_password_editbox").focus();
			document.getElementById("general_password_editbox").select();
			return false;
		}
	
		// get kernel state
		var kernelState = CometMarksKernel.getState();
		if ( kernelState.is_login && g_username == aUsername && g_password == aPassword )
		{
			if ( overwrite_win )// has opened
			{
				overwrite_win.focus();
			}
		}
		else
		{	
			// logout first
			CometMarksKernel.logOut();
			
			// set passport username
			CometPassport.setUsername( aUsername, aPassword );
		}
	  
		// enable logging
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = prefService.getBranch("cometmarks.");
		if ( document.getElementById("general_enablelogging_checkbox").checked )
			prefs.setBoolPref("enable_logs", true);
		else
			prefs.setBoolPref("enable_logs", false);
			
		// remeber password
		if ( document.getElementById("general_autologin_checkbox").checked )
			prefs.setBoolPref("autologin", true);
		else
			prefs.setBoolPref("autologin", false);
	
		return true;
	}catch(e){write_log(e);}
	},
	
	// show log of sync process
	showLog : function()
	{
		cometmarks_show_logs();
	},
	
	// open get forget password web page of bookmarks
	getForgotPassword : function()
	{
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var url = bubble.GetStringFromName("cometmarks.settingdialog.forgot_password.url");
		CometMarksUtility.openURL( url );
	},
	
	openIECometmarks : function()
	{
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var url = bubble.GetStringFromName("cometmarks.settingdialog.iecometmarks.url");
		CometMarksUtility.openURL( url );
	},
	
	openHelpUrl : function()
	{
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var url = bubble.GetStringFromName("cometmarks.settingdialog.help.url");
		CometMarksUtility.openURL( url );
	},
	
	openHomePage : function()
	{
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var url = bubble.GetStringFromName("cometmarks.settingdialog.homepage.url");
		CometMarksUtility.openURL( url );
	},
	
	// open registerCometMarks web page of bookmarks
	registerCometMarks : function()
	{
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var url = bubble.GetStringFromName("cometmarks.settingdialog.register.url");
		CometMarksUtility.openURL( url );
	},
	
	// remeber password when input password textbox
	setRemeberPasswordCheck : function()
	{
		document.getElementById("general_autologin_checkbox").setAttribute("checked", "true");
	},
	
	doUnload : function()
	{
		if ( SettingStateObserver != null && SettingStateObserver != undefined )
		{
			var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
			observerService.removeObserver( SettingStateObserver, CometMarksKernelDefine.event_update );
			observerService.removeObserver( SettingStateObserver, CometMarksKernelDefine.event_sync );
			observerService.removeObserver( SettingStateObserver, CometMarksKernelDefine.event_overwrite );
			observerService.removeObserver( SettingStateObserver, CometMarksKernelDefine.event_logout );
			observerService.removeObserver( SettingStateObserver, CometMarksKernelDefine.event_bookmarks_changed );
		}
	}
};