/* define cometmarks notes const variables */
if( typeof( CometMarksStatusBarDefined ) == "undefined" )
{
	try
	{
		eval('																								\r\n\
			const CometMarksStatusBarDefined =																\r\n\
			{																								\r\n\
				// statusbar changed																		\r\n\
				event_statusbarmenu_changed				:	"cometmarks.statusbar.event.statusbar_changed"		\r\n\
			};																								\r\n\
		');
	} 
	catch( e ) 
	{
		alert ( e ); 
	}
}

/* update statis ui state */	
var StatusBarStateObserver = 
{
	show_timer		: null,
	
	observe : function( subject, topic, data ) 
	{
		switch( topic )
		{
			case CometMarksKernelDefine.event_update :				
			case CometMarksKernelDefine.event_sync :	
			case CometMarksKernelDefine.event_overwrite :
			case CometMarksKernelDefine.event_bookmarks_changed :
			case CometMarksKernelDefine.event_logout :
			case CometMarksStatusBarDefined.event_statusbarmenu_changed :
				this.updateStatusBarUI();
				break;
				
			case CometMarksNotesDefined.event_note_status:
				this.showNotesStatus( data );
				break;
				
			default :
				break;
		}
	},
	
	showNotesStatus : function( status )
	{
		if ( status == CometMarksNotesDefined.status_close )
		{	
			var note_statebar = document.getElementById("cometmarks_show_note_statebar");
			note_statebar.removeAttribute( "checked" );
		}
	},
	
	updateStatusBarUI : function()
	{
		// show or hide statusbar
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = prefService.getBranch( "cometmarks." );
		var hide_statusicon = prefs.getBoolPref( "hidestatusicon" );
		document.getElementById("cometmarks_statusbarpanel").hidden = hide_statusicon;
		
		// show the username in statusbar
		var aUsername = CometPassport.getUsername();

		var state_text = document.getElementById("statusbar_text");
		if ( aUsername.length == 0 )
			state_text.setAttribute( "value", "N/A" );
		else
			state_text.setAttribute( "value", aUsername );

		// show state image in statusbar
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var state_image = document.getElementById("statusbar_image");
		
		// show note image
		var state_note_image = document.getElementById("statusbar_note_image");
		state_note_image.tooltipText = bubble.GetStringFromName("cometmarks.status.note.toolstip");
		
		var kernelState = CometMarksKernel.getState();
		var status = kernelState.work_state;
		
		// show state as popup
		clearTimeout( this.show_timer );
		this.show_timer = setTimeout( function(){ PopupStateInfo.show( status );}, 500);
		
		// clear conneting 
		state_image.setAttribute("status", "none");
		
		if ( status == CometMarksKernelDefine.work_state_changed )
		{
			// image
			state_image.setAttribute("status", "pending");
			return;
		}
		
		if ( status == CometMarksKernelDefine.work_state_success )
		{
			// image
			state_image.setAttribute("status", "ok");
			state_note_image.setAttribute("status", "login");
			return;
		}
		
		if ( status == CometMarksKernelDefine.work_state_invalid_password )
		{
			// image
			state_image.setAttribute("status", "failed");
			state_note_image.setAttribute("status", "logout");
			return;
		}
		
		if ( status == CometMarksKernelDefine.work_state_out_of_date )
		{
			// image
			state_image.setAttribute("status", "failed");
			return;
		}
		
		if ( status == CometMarksKernelDefine.work_state_connect_failed )
		{
			// image
			state_image.setAttribute("status", "failed");
			return;
		}
		
		if ( status == CometMarksKernelDefine.work_state_no_record )
		{
			// image
			state_image.setAttribute("status", "ok");
			state_note_image.setAttribute("status", "login");
			return;
		}
		
		if ( status == CometMarksKernelDefine.work_state_syncing )
		{
			// image
			state_image.setAttribute("status", "syncing");
			return;
		}
		
		if ( status == CometMarksKernelDefine.work_state_updating )
		{
			// image
			state_image.setAttribute("status", "syncing");
			return;
		}
		
		if ( status == CometMarksKernelDefine.work_state_overwriting )
		{
			// image
			state_image.setAttribute("status", "syncing");
			return;
		}
		
		if ( status == CometMarksKernelDefine.work_state_no_login )
		{
			// image
			state_image.setAttribute("status", "logout");
			state_note_image.setAttribute("status", "logout");
			return;
		}
		
		if ( status == CometMarksKernelDefine.work_state_exception )
		{
			// image
			state_image.setAttribute("status", "failed");
		}
	}
};

/* deal with statusbar xul */
var CometmarksStatusBarHandler = 
{
	click_timer				: null,
	
	init : function()
	{    		
		// add observer and update status
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver( StatusBarStateObserver, CometMarksKernelDefine.event_update, false );
		observerService.addObserver( StatusBarStateObserver, CometMarksKernelDefine.event_sync, false );
		observerService.addObserver( StatusBarStateObserver, CometMarksKernelDefine.event_overwrite, false );
		observerService.addObserver( StatusBarStateObserver, CometMarksKernelDefine.event_logout, false );
		observerService.addObserver( StatusBarStateObserver, CometMarksKernelDefine.event_bookmarks_changed, false );
		observerService.addObserver( StatusBarStateObserver, CometMarksNotesDefined.event_note_status, false );
		observerService.addObserver( StatusBarStateObserver, CometMarksStatusBarDefined.event_statusbarmenu_changed, false );
		
		// update statusbar 
		observerService.notifyObservers( null, CometMarksStatusBarDefined.event_statusbarmenu_changed, null );
	},
	
	release : function()
	{
		// remove observer
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver( StatusBarStateObserver, CometMarksKernelDefine.event_update );
		observerService.removeObserver( StatusBarStateObserver, CometMarksKernelDefine.event_sync );
		observerService.removeObserver( StatusBarStateObserver, CometMarksKernelDefine.event_overwrite );
		observerService.removeObserver( StatusBarStateObserver, CometMarksKernelDefine.event_logout );
		observerService.removeObserver( StatusBarStateObserver, CometMarksKernelDefine.event_bookmarks_changed );
		observerService.removeObserver( StatusBarStateObserver, CometMarksNotesDefined.event_note_status );
		observerService.removeObserver( StatusBarStateObserver, CometMarksStatusBarDefined.event_statusbarmenu_changed );
	},
	
	openSettingDialog : function( event )
	{
		// close popup first
		var bookmakrs_popup = document.getElementById("bookmarksMenuPopup");
		if ( bookmakrs_popup )
		{
			bookmakrs_popup.hidePopup();
		}
		
		// cancel show popup
		clearTimeout( CometmarksStatusBarHandler.click_timer );
		CometmarksStatusBarHandler.click_timer = null;
			
		// Handle different event models
		if ( event.button != 0 )// no left mouse
			return;
		
		if ( event.detail > 1)// dobule click
		{
			if ( event.target.id == "cometmarks_statusbarpanel" || event.target.id == "statusbar_image" || event.target.id == "statusbar_text" )
			{
				// to open the setting dialog
				CometMarksUtility.getCometMarksSettingDialog();	
			}
			return;
		}
		
		/*
		// remove: open bookmarks when left click
		CometmarksStatusBarHandler.click_timer = setTimeout( function()// delay 200ms
		{
			var menu_bookmakrs_popup = document.getElementById("bookmarksMenuPopup");
			var statarbar = document.getElementById("statusbar_image");
			if ( menu_bookmakrs_popup ) // open popup
			{
				menu_bookmakrs_popup.openPopupAtScreen( statarbar.boxObject.screenX, statarbar.boxObject.screenY-1, false );
			}
		}, 200);
		*/
	},
	
	toggleIcon : function()
	{     
		// set new value
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = prefService.getBranch( "cometmarks." );
		var hide_statusicon = prefs.getBoolPref( "hidestatusicon" );
		prefs.setBoolPref( "hidestatusicon", !hide_statusicon );
		
		// notify
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.notifyObservers( null, CometMarksStatusBarDefined.event_statusbarmenu_changed, null );
	},
	
	showMenuPopup : function()
	{
		// change check
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var prefs = prefService.getBranch( "cometmarks." );
		var hide_statusicon = prefs.getBoolPref( "hidestatusicon" );
		
		if ( !hide_statusicon )// set check
		{
			document.getElementById("cometmarks_showstatusicon_status").setAttribute( "checked", "true" );
		}
		else // remove check
		{
			document.getElementById("cometmarks_showstatusicon_status").removeAttribute( "checked" );
		}
		
		// note disable or able
		var kernelState = CometMarksKernel.getState();
		if (  kernelState.work_state == CometMarksKernelDefine.work_state_no_login || kernelState.work_state == CometMarksKernelDefine.work_state_invalid_password )
		{
			// note statuabar item able
			document.getElementById("cometmarks_show_note_statebar").setAttribute("disabled", "true");
			
			document.getElementById("cometmarks_logout_statebar").setAttribute("disabled", "true");
		}
		else
		{
			// note statuabar item disabled
			document.getElementById("cometmarks_show_note_statebar").setAttribute("disabled", "false");
			
			document.getElementById("cometmarks_logout_statebar").setAttribute("disabled", "false");
		}
	},
	
	openNotes : function( event )
	{
	try{
		if ( event.button != 0 )
			return;
			
		if ( event.target.id != "cometmarks_status_note" && event.target.id != "statusbar_note_image" )
			return;
			
		var note_image = document.getElementById("statusbar_note_image");
		if ( note_image.getAttribute("status") != "login" ) 
			return;
			
		// open notes
		CometmarksNotesHandler.showNotePanel();
	}catch(e){ CometMarksUtility.showCatchMessage( e ); }
	},
	
	getIntervalLastSyncTime : function()
	{
		// get now time
		var now = new Date();
		var now_seconds = now.getSeconds();
		now_seconds += now.getMinutes() * 60;
		now_seconds += now.getHours() * 3600;
		
		// get last sync time
		var globalData = CometMarksGlobal.getGlobalData();
		if ( globalData.last_sync_time == null )
			return "NO_SYNC_SUCCESS";
			
		var last_time = new Date( globalData.last_sync_time );
		var last_seconds = last_time.getSeconds();
		last_seconds += last_time.getMinutes() * 60;
		last_seconds += last_time.getHours() * 3600;
		
		if ( now_seconds < last_seconds )// i.e: when 23:59:59 to 00:00:01
			now_seconds += 24 * 3600;
			
		var interval_seconds = now_seconds - last_seconds;
		var minute = Math.floor( interval_seconds / 60);
		var second = interval_seconds % 60;
		
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var interval_time_str = "";
		
		// get home lang
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        var prefs = prefService.getBranch("");
		var home_lang = prefs.getCharPref( "general.useragent.locale" );
		if ( home_lang == "zh-CN" )
		{
			if ( minute > 0 ) // show minite
				interval_time_str = minute + bubble.GetStringFromName("cometmarks.status.min") + " " + bubble.GetStringFromName("cometmarks.status.end");
			else
				interval_time_str = second + bubble.GetStringFromName("cometmarks.status.sec") + " " + bubble.GetStringFromName("cometmarks.status.end");
		}
		else
		{
			if ( second == 0 )
				second = 1;
				
			if ( second < 10 )	
				second = "0" + second;
				
			if ( minute < 10 )	
				minute = "0" + minute;
				
			interval_time_str = minute + bubble.GetStringFromName("cometmarks.status.min") + second + bubble.GetStringFromName("cometmarks.status.sec") + " " + bubble.GetStringFromName("cometmarks.status.end");
		}
		return interval_time_str;
	},
	
	setTooltipText : function()
	{
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var status = CometMarksKernel.getState().work_state;
		
		if ( status == CometMarksKernelDefine.work_state_success )
		{
			return bubble.GetStringFromName("cometmarks.status.success.text") + " " + CometmarksStatusBarHandler.getIntervalLastSyncTime();
		}
		
		if ( status == CometMarksKernelDefine.work_state_connect_failed )
		{
			if ( CometmarksStatusBarHandler.getIntervalLastSyncTime() == "NO_SYNC_SUCCESS" )
				return bubble.GetStringFromName("cometmarks.status.failed.text.no_sync_success");
			else
				return bubble.GetStringFromName("cometmarks.status.failed.text") + " "+ CometmarksStatusBarHandler.getIntervalLastSyncTime();
		}
		
		if ( status == CometMarksKernelDefine.work_state_changed )
		{
			return bubble.GetStringFromName("cometmarks.status.wait");
		}
		
		if ( status == CometMarksKernelDefine.work_state_invalid_password )
		{
			return bubble.GetStringFromName("cometmarks.status.invalid.password");
		}
		
		if ( status == CometMarksKernelDefine.work_state_out_of_date )
		{
			return bubble.GetStringFromName("cometmarks.status.out.of.date");
		}
		
		if ( status == CometMarksKernelDefine.work_state_no_record )
		{
			return bubble.GetStringFromName("cometmarks.status.success");
		}
		
		if ( status == CometMarksKernelDefine.work_state_syncing )
		{
			return bubble.GetStringFromName("cometmarks.status.syncing");
		}
		
		if ( status == CometMarksKernelDefine.work_state_updating )
		{
			return bubble.GetStringFromName("cometmarks.status.updating");
		}
		
		if ( status == CometMarksKernelDefine.work_state_overwriting )
		{
			return bubble.GetStringFromName("cometmarks.status.overwriting");
		}
		
		if ( status == CometMarksKernelDefine.work_state_no_login )
		{
			return bubble.GetStringFromName("cometmarks.status.no.login");
		}
		
		if ( status == CometMarksKernelDefine.work_state_exception )
		{
			return bubble.GetStringFromName("cometmarks.status.exception");
		}
	}
};

var PopupStateInfo = 
{
	has_show	: false,
	
	show: function( workState ) 
	{
		if ( workState == CometMarksKernelDefine.work_state_success || workState == CometMarksKernelDefine.work_state_changed 
			|| workState == CometMarksKernelDefine.work_state_no_record || workState == CometMarksKernelDefine.work_state_syncing
			|| workState == CometMarksKernelDefine.work_state_updating || workState == CometMarksKernelDefine.work_state_overwriting 
			|| workState == CometMarksKernelDefine.work_state_no_login )
			return;
		
		if ( PopupStateInfo.has_show )
			return;
			
		PopupStateInfo.has_show = true;
		// using popup-blocked in system
		var notificationBox = gBrowser.getNotificationBox();
		var notification = notificationBox.getNotificationWithValue("popup-blocked");
		
		// set message and image for popup
		var bubble = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://cometmarks/locale/cometmarks.properties");
		var buttonLabel = bubble.GetStringFromName("cometmarks.status.pupup.button.label");
		var image_url = "chrome://cometmarks/skin/state_error_16.png";
		var message = "";
		
		if ( CometMarksKernelDefine.work_state_invalid_password == workState )
		{
			message = bubble.GetStringFromName("cometmarks.status.invalid.password");
		}
		else if ( CometMarksKernelDefine.work_state_out_of_date == workState )
		{
			message = bubble.GetStringFromName("cometmarks.status.out.of.date");
		}
		else if ( CometMarksKernelDefine.work_state_connect_failed == workState )
		{
			message = bubble.GetStringFromName("cometmarks.status.connect.failed");
		}
		else if ( CometMarksKernelDefine.work_state_exception == workState )
		{
			message = bubble.GetStringFromName("cometmarks.status.exception");
		}
			
		if ( notification ) 
		{
			notification.label = message;// change
		}
		else 
		{	
			// add button if need
			var buttons = [{
			label: buttonLabel,
			accessKey: "E",
			popup: null, // blockedPopupOptions
			callback: PopupStateInfo.settingCallback // null PopupStateInfo.settingCallback
			}];
			
			// show new
			const priority = notificationBox.PRIORITY_WARNING_HIGH;
			notificationBox.appendNotification( message, 
												"popup-blocked",
												image_url,
												priority, 
												buttons );// null buttons
		}	
		
		// close after 10 seconds
		window.setTimeout( function(){ 
			notificationBox.removeCurrentNotification(); 
		}, 10000 );
	},
	
	settingCallback : function() 
	{
		// deal with button of popup block 
		CometMarksUtility.getCometMarksSettingDialog();
	}
};

window.addEventListener( "load", CometmarksStatusBarHandler.init, false );
window.addEventListener( "unload", CometmarksStatusBarHandler.release, false );